
package org.netbeans.modules.asm.x86.syntax.att;

import java.io.Reader;
import java.util.ArrayList;
import java.util.List;

import org.netbeans.modules.asm.model.lang.AsmOffsetable;
import org.netbeans.modules.asm.model.lang.operand.LabelOperand;
import org.netbeans.modules.asm.x86.syntax.*;
import org.netbeans.modules.asm.x86.syntax.att.fake.*;
import org.netbeans.modules.asm.x86.syntax.att.generated.*;

//ToDo: in upper level

public class ATTParser { 
    
    private X86Lexer lexer;
    
    public ATTParser(Reader source) {
        lexer = new X86Lexer(new ATTScanner(source));
    }
    
    public List<AsmOffsetable> parse() {
        List<AsmOffsetable> res = new ArrayList<AsmOffsetable>();
             
        for (X86Token tok: lexer.getTokens()) {
            String text = tok.getText();
            
            if (tok.getId() == X86TokenId.ASM_LABEL) {
                                
                LabelOperand.Direction dir = LabelOperand.Direction.BIDIRECTIONAL;                        
                
                if (text.charAt(text.length() - 1) == 'b') {
                    dir = LabelOperand.Direction.BACK;
                    text = text.substring(0, text.length() - 1);
                } else if (text.charAt(text.length() - 1) == 'f') {
                    dir = LabelOperand.Direction.FORWARD;
                    text = text.substring(0, text.length() - 1);    
                }
                
                X86LabelOperand op = new X86LabelOperand(text);
                res.add(new X86OperandInstance(op, tok.getStartOffset(),
                                               tok.getEndOffset()));
                         
            }
            else if (tok.getId() == X86TokenId.ASM_LABEL_INST) {
                res.add(new X86LabelInstance(text.substring(0, text.length() - 1), 
                                             tok.getStartOffset(), 
                                             tok.getEndOffset()));
            }
        }
        return res;
    }    
}
