/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.test.bpel.verification.lib;

import org.netbeans.jemmy.operators.JButtonOperator;
import org.netbeans.jemmy.operators.JComboBoxOperator;
import org.netbeans.jemmy.operators.JDialogOperator;
import org.netbeans.jemmy.operators.JTextFieldOperator;
import org.netbeans.jemmy.operators.Operator;
import org.netbeans.orchlib.core.operators.PatternOperator;

/**
 *
 * @author mikk@netbeans.org
 */
public class DiagramManager {
    
    /** Creates a new instance of DiagramManager */
    public DiagramManager() {
    }
    
    public static void callPopupOnPattern(PatternOperator op, String menuPath){
        op.getPopup().pushMenuNoBlock(menuPath);
    }
    
    public static void setBasicReceiveProperties(JDialogOperator propertiesEditor, String receiveName){
        
        JTextFieldOperator txtName = new JTextFieldOperator(propertiesEditor, 1);
        txtName.clearText();
        txtName.waitText("");
        txtName.typeText(receiveName);
        
        JComboBoxOperator cmbPartner = new JComboBoxOperator(propertiesEditor, 0);
        cmbPartner.selectItem(0);
        cmbPartner.waitItemSelected(0);
        
        JComboBoxOperator cmbOperation = new JComboBoxOperator(propertiesEditor, 1);
        cmbOperation.selectItem(0);
        cmbOperation.waitItemSelected(0);
        
        new JButtonOperator(propertiesEditor, "Create").pushNoBlock();
        JDialogOperator dlgVar = new JDialogOperator("New Input Variable");
        JButtonOperator btnOk = new JButtonOperator(dlgVar, "Ok");
        try{
            btnOk.waitComponentEnabled();
        }catch(Exception e){}
        btnOk.pushNoBlock();
        dlgVar.waitClosed();
        
        
        new JButtonOperator(propertiesEditor, "Ok").pushNoBlock();
        propertiesEditor.waitClosed();
    }
    
    
    public static void verifyPatternName(PatternOperator pat, String name) throws VerificationException{
        if (!pat.getName().equals(name)){
            throw new VerificationException("Pattern name verification on diagram failed");
        }
        //TODO: add source verification
    }
    
}
