/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.test.bpel.verification.lib;

import org.netbeans.jellytools.ProjectsTabOperator;
import org.netbeans.jellytools.nodes.Node;
import org.netbeans.jellytools.nodes.ProjectRootNode;

/**
 *
 * @author mikk@netbeans.org
 */
public class Util {
    
    /** Creates a new instance of Util */
    public Util() {
    }
    
    public final static String PROCESS_SOURCES_PATH = "Process Files";
    
    public static void verifyProjectPath(String projectName, String subPath) throws VerificationException{
        try{
            ProjectsTabOperator pto = ProjectsTabOperator.invoke();
            ProjectRootNode root = new ProjectRootNode(pto.tree(),projectName);
                       
            Node processFilesNode = new Node(root, subPath);
            processFilesNode.tree().setVerification(true);
            processFilesNode.select();
            
        }catch(Exception e){
            VerificationException ex = new VerificationException(e, "Some of the project nodes was not found");            
            throw ex;
        } 
    }
    
}
