/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


/*
 * IActionalble.java
 */

package org.netbeans.orchlib.core.operators;

import java.awt.Point;

/**
 * Basic class that represents any element on the diagram that may be useful for testing
 * The action point is the point that may be clicked to select the element
 * @author Mikhail.Kondratyev@sun.com
 */
public interface IActionable {
    
    
    /**
     * Returns point that has to be clicked to perform some actions on the element
     * @return Point (usually to click on)
     */
    public Point getActionPoint();   
    
}
