/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


/*
 * PatternTypes.java
 */

package org.netbeans.orchlib.core.operators;

/**
 *This enum contains various possible Patterns available on the BPEL diagrams
 * @author Mikhail.Kondratyev@sun.com
 */
public enum PatternTypes {
    /* This means ANY pattern */
    ANY("Any"),
    PROCESS("org.netbeans.modules.bpel.model.impl.ProcessImpl"),
    SEQUENCE("org.netbeans.modules.bpel.model.impl.SequenceImpl"),
    RECEIVE("org.netbeans.modules.bpel.model.impl.ReceiveImpl"),
    ASSIGN("org.netbeans.modules.bpel.model.impl.AssignImpl"),    
    SWITCH("org.netbeans.modules.bpel.model.impl.IfImpl"),
    SWITCH_CASE("org.netbeans.modules.bpel.model.impl.CaseImpl"),
    IF("org.netbeans.modules.bpel.model.impl.IfImpl"),
    INVOKE("org.netbeans.modules.bpel.model.impl.InvokeImpl"),
    PARTNER_LINK("org.netbeans.modules.bpel.model.impl.PartnerLinkImpl"),
    PICK("org.netbeans.modules.bpel.model.impl.PickImpl"),
    EMPTY("org.netbeans.modules.bpel.model.impl.EmptyImpl"),
    ON_ALARM("org.netbeans.modules.bpel.model.impl.OnAlarmPickImpl"),
    ON_MESSAGE("org.netbeans.modules.bpel.model.impl.OnMessageImpl"),
    REPLY("org.netbeans.modules.bpel.model.impl.ReplyImpl"),
    COMPENSATE("org.netbeans.modules.bpel.model.impl.CompensateImpl"),
    WAIT("org.netbeans.modules.bpel.model.impl.WaitImpl"),
    SCOPE("org.netbeans.modules.bpel.model.impl.ScopeImpl"),
    WHILE("org.netbeans.modules.bpel.model.impl.WhileImpl"),
    FLOW("org.netbeans.modules.bpel.model.impl.FlowImpl"),
    DEFAULT("Default"),
    THROW("org.netbeans.modules.bpel.model.impl.ThrowImpl"),
    EVENT_HANDLER("org.netbeans.modules.bpel.model.impl.EventHandlersImpl"),
    COMPENSATION_HANDLER("org.netbeans.modules.bpel.model.impl.CompensationHandlerImpl"),
    //COMPENSATION_HANDLER("org.netbeans.modules.bpel.model.impl.CompensatableActivityHolderImpl"),
    FAULT_HANDLER("org.netbeans.modules.bpel.model.impl.FaultHandlersImpl"),
    CATCH("org.netbeans.modules.bpel.model.impl.CatchImpl"),
    CATCH_ALL("org.netbeans.modules.bpel.model.impl.CatchAllImpl"),
    EXIT("org.netbeans.modules.bpel.model.impl.ExitImpl"),
    IF_THEN("org.netbeans.modules.bpel.model.impl.ThenImpl"),
    IF_ELSE("org.netbeans.modules.bpel.model.impl.ElseImpl"),
    ELSEIF("org.netbeans.modules.bpel.model.impl.ElseIfImpl"),
    FOR_EACH("org.netbeans.modules.bpel.model.impl.ForEachImpl"),
    REPEAT_UNTIL("org.netbeans.modules.bpel.model.impl.RepeatUntilImpl");
    
    
    private String val = "";
    
    private PatternTypes(String val){
        this.val = val;
    }
    
    public String toString(){
        return val;
    }
}