/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

/*
 * ProcessCreateAction.java
 *
 */

package org.netbeans.orchlib.ext.creator.actions;

import org.netbeans.orchlib.core.operators.ElementTypes;
import org.netbeans.orchlib.core.operators.PatternOperator;
import org.netbeans.orchlib.core.operators.PatternTypes;
import org.netbeans.orchlib.core.operators.VisualElementOperator;
import org.netbeans.orchlib.exceptions.ElementNotFoundException;
import org.netbeans.orchlib.ext.creator.exceptions.CreationVerificationException;
import org.netbeans.jemmy.EventTool;


/**
 *
 * @author Mikhail.Kondratyev@sun.com
 */
public class BasePatternCreateAction extends CreateAction{
    
    /** Creates a new instance of ProcessCreateAction */
    public BasePatternCreateAction() {
    }
    
    public PatternOperator perform(PatternOperator pattern, PatternTypes type) throws ElementNotFoundException, CreationVerificationException{
        int countTypeBefore = pattern.getChildPatternsCount(type);
        VisualElementOperator placeHolder = new VisualElementOperator(pattern, ElementTypes.PLACEHOLDER_ELEMENT, 0);
        pattern.getDesignView().createPatternFromPalette(type, placeHolder);
        
        //verification
        int countTypeAfter = pattern.getChildPatternsCount(type);
        if (countTypeAfter-countTypeBefore!=1){
            throw new CreationVerificationException("Could not create an activity of type "+type.name()+" in container named "+pattern.getName());
        }
        return pattern.getDirectChildPattern(type, 0);
        
    }
}
