/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

/*
 * CreateAction.java
 *
 */

package org.netbeans.orchlib.ext.creator.actions;

import org.netbeans.orchlib.core.operators.PatternOperator;
import org.netbeans.orchlib.core.operators.PatternTypes;
import org.netbeans.orchlib.exceptions.ElementNotFoundException;
import org.netbeans.orchlib.ext.creator.exceptions.CreationVerificationException;

/**
 * Base class used for all create actions. These actions are called while building a BPEL diagram
 * @author Mikhail.Kondratyev@sun.com
 */
public class CreateAction {
    
    /** Creates a new instance of CreateAction */
    public CreateAction() {
    }
    
    /**
     * The method is called to create a new activity of some type.
     * The pattern to create child in is specified by the pattern parameter,
     * the type of pattern to be created is specified by the type parameter
     * @param parent The pattern to create activity in
     * @param type The type of activity to be created
     * @throws orchlib.exceptions.ElementNotFoundException 
     * @throws orchlib.ext.creator.exceptions.CreationVerificationException 
     * @return Return the created activity
     */
    public PatternOperator perform(PatternOperator parent, PatternTypes type) throws ElementNotFoundException, CreationVerificationException{
        return null;
    }
}
