/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.orchlib.ext.operators;

import javax.swing.text.JTextComponent;
import org.netbeans.orchlib.utils.ITitlesAndLabels;
import org.netbeans.jellytools.WizardOperator;
import org.netbeans.jemmy.operators.JButtonOperator;
import org.netbeans.jemmy.operators.JLabelOperator;
import org.netbeans.jemmy.operators.JTextComponentOperator;

/**
 * The class is used to handle New WSDL file dialog
 */
public class OrchNewWSDLStepOperator extends WizardOperator{
    
    public static final String WZRD_TITLE = "New WSDL File";
    public static final String FILE_NAME_LBL = "File Name";
    public static final String FOLDER_LBL = "Folder";
    
    public OrchNewWSDLStepOperator() {
        super(WZRD_TITLE);
    }
    
    public JTextComponentOperator txtWSDLName(){        
        JLabelOperator lbl = new JLabelOperator(this, FILE_NAME_LBL);
        JTextComponentOperator txtName = null;
        if (lbl.getLabelFor()!=null){
            txtName = new JTextComponentOperator((JTextComponent)lbl.getLabelFor());
        }
        return txtName;        
    }
    
    public JTextComponentOperator txtFolderName(){        
        JLabelOperator lbl = new JLabelOperator(this, FOLDER_LBL);
        JTextComponentOperator txtName = null;
        if (lbl.getLabelFor()!=null){
            txtName = new JTextComponentOperator((JTextComponent)lbl.getLabelFor());
        }
        return txtName;        
    }
    
    public JButtonOperator btnFinish(){
        return new JButtonOperator(this, ITitlesAndLabels.BTN_FINISH);
    }
    
        
}
