/*
 * The contents of this file are subject to the terms of the Common
 * Development and Distribution License (the License). You may not use this
 * file except in compliance with the License.  You can obtain a copy of the
 * License at http://www.netbeans.org/cddl.html
 
 * When distributing Covered Code, include this CDDL Header Notice in each
 * file and include the License. If applicable, add the following below the
 * CDDL Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 
 * Copyright 2006 Sun Microsystems, Inc. All Rights Reserved
 *
 */

package org.netbeans.modules.aspect.editor.graph.panels;

import org.netbeans.modules.aspect.editor.jaxbmodel.ExchangeSimpleType;
import org.netbeans.modules.aspect.editor.model.AspectMap;

/**
 *
 * @author  karthikeyan s
 */
public class EditAspectTypePanel extends javax.swing.JPanel {
    
    /** Creates new form EditAspectTypePanel */
    public EditAspectTypePanel() {
        initComponents();
    }
    
    public String getSelected() {
        if(oneWay.isSelected()) {
            //return AspectMap.FILTER_ONE_WAY_ELEMENT;
            return ExchangeSimpleType.FILTER_ONE_WAY.value();
        } else if(filterReqReply.isSelected()) {
            //return AspectMap.FILTER_REQUEST_REPLY_ELEMENT;
            return ExchangeSimpleType.FILTER_REQUEST_REPLY.value();
        } else{
            return ExchangeSimpleType.REQUEST_REPLY.value();
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        filterReqReply = new javax.swing.JRadioButton();
        oneWay = new javax.swing.JRadioButton();
        reqReply = new javax.swing.JRadioButton();

        jRadioButton1.setText("jRadioButton1");
        jRadioButton1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jRadioButton2.setText("jRadioButton2");
        jRadioButton2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        jRadioButton2.setMargin(new java.awt.Insets(0, 0, 0, 0));

        jLabel1.setText(org.openide.util.NbBundle.getMessage(EditAspectTypePanel.class, "EditAspectTypePanel.jLabel1.text")); // NOI18N

        buttonGroup1.add(filterReqReply);
        filterReqReply.setText(org.openide.util.NbBundle.getMessage(EditAspectTypePanel.class, "EditAspectTypePanel.reqReply.text_1")); // NOI18N
        filterReqReply.setToolTipText("Filter Rqst Reply Aspect");
        filterReqReply.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        filterReqReply.setMargin(new java.awt.Insets(0, 0, 0, 0));

        buttonGroup1.add(oneWay);
        oneWay.setSelected(true);
        oneWay.setText(org.openide.util.NbBundle.getMessage(EditAspectTypePanel.class, "EditAspectTypePanel.oneWay.text")); // NOI18N
        oneWay.setToolTipText("Filter One Way Aspect");
        oneWay.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        oneWay.setMargin(new java.awt.Insets(0, 0, 0, 0));

        buttonGroup1.add(reqReply);
        reqReply.setText("Request Reply");
        reqReply.setToolTipText("Rqst Reply Aspect");
        reqReply.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        reqReply.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .add(32, 32, 32)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(reqReply)
                    .add(filterReqReply)
                    .add(layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(oneWay)))
                .add(21, 21, 21))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(oneWay))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(filterReqReply)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(reqReply)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    javax.swing.ButtonGroup buttonGroup1;
    javax.swing.JRadioButton filterReqReply;
    javax.swing.JLabel jLabel1;
    javax.swing.JRadioButton jRadioButton1;
    javax.swing.JRadioButton jRadioButton2;
    javax.swing.JRadioButton oneWay;
    javax.swing.JRadioButton reqReply;
    // End of variables declaration//GEN-END:variables
    
}
