/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 *
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 *
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */
package org.netbeans.modules.aspect.editor.property.propBeans;

import java.util.HashMap;
import org.netbeans.modules.aspect.editor.jaxbmodel.AdviceType;
import org.netbeans.modules.aspect.editor.mapbuilder.AspectMapBuilder;
import org.netbeans.modules.aspect.editor.jaxbutils.AspectConstants;

/**
 *
 *
 * @author $Author$
 * @version $Revision$
 */

public class logging {
    
    private AdviceType adviceType;
    private HashMap propModel;
    
    public logging(AdviceType ad){
        this.adviceType = ad;
        propModel = AspectMapBuilder.getAspectMapBuilder().getAdviceProperties(ad);
    }
    
    public String getLevel(){
        return (String)propModel.get(AspectConstants.LOG_TAG_VERBOSITY);
    }
    
    public void setLevel(String level){
        AspectMapBuilder.getAspectMapBuilder().setAdviceProperties(this.adviceType, AspectConstants.LOG_TAG_VERBOSITY, level);
    }
    
    public String getRotationPolicy(){
        return (String)propModel.get(AspectConstants.LOG_TAG_ROTATIONPOLICY);
    }
    
    public void setRotationPolicy(String policy){
        AspectMapBuilder.getAspectMapBuilder().setAdviceProperties(this.adviceType, AspectConstants.LOG_TAG_ROTATIONPOLICY, policy);
        
    }
    
    public String getLogFileLocation(){
        return (String)propModel.get(AspectConstants.LOG_TAG_FILE);
    }
    
    public void setLogFileLocation(String logFileLocation){
        
        AspectMapBuilder.getAspectMapBuilder().setAdviceProperties(this.adviceType, AspectConstants.LOG_TAG_FILE, logFileLocation);
    }
    
}
