/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */

package org.netbeans.modules.aspect.project.compapp;

import org.netbeans.modules.aspect.project.ui.wizards.*;
import org.netbeans.modules.aspect.project.AspectProjectGenerator;
import java.io.File;
import java.io.IOException;
//import org.netbeans.modules.compapp.projects.jbi.api.InternalProjectTypePluginWizardIterator;



/**
 * Wizard to create a new Internal Composite Application Project Type project.
 * 
 * This is just an example of how to create a wizard iterator for:
 * - an Aspect that contains one "Logging" Advice.
 * 
 * The project that is created is just an empty default Aspect SE Project.
 * Note that this is somewhat inaccurate as the project is supposed to
 * correspond to an Aspect with one "Logging" Advice.
 * 
 * So, there should be some way to add the "Logging" Advice to the aspectmap.xml
 * within this project. In any case this example does not make any attempt to do so.
 * 
 */
public class InternalAspectProjectTypeWizardIterator_Logging {//extends InternalProjectTypePluginWizardIterator {

    // Creates the project at the given file location with the given project name.
    // 
    // TODO: is j2eeLevel used?
    protected void createProject(File dirF, String name, String j2eeLevel) throws IOException {
        AspectProjectGenerator.createProject(dirF, name, j2eeLevel);
    }
    
}
