/*
 * The contents of this file are subject to the terms of the Common Development
 * and Distribution License (the License). You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the License at http://www.netbeans.org/cddl.html
 * or http://www.netbeans.org/cddl.txt.
 * 
 * When distributing Covered Code, include this CDDL Header Notice in each file
 * and include the License file at http://www.netbeans.org/cddl.txt.
 * If applicable, add the following below the CDDL Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 */


package org.netbeans.modules.wlm.model.impl;

import java.util.List;

import org.netbeans.modules.wlm.model.api.TAction;
import org.netbeans.modules.wlm.model.api.TNotification;
import org.netbeans.modules.wlm.model.api.WLMComponent;
import org.netbeans.modules.wlm.model.api.WLMModel;
import org.netbeans.modules.wlm.model.api.WLMVisitor;
import org.w3c.dom.Element;

public class NotificationImpl extends WLMComponentBase implements TNotification {

	public NotificationImpl(WLMModel model, Element e) {
		super(model, e);
		// TODO Auto-generated constructor stub
	}

	public NotificationImpl(WLMModel model) {
		this(model, createNewElement(WLMQNames.NOTIFICATION.getQName(), model));
	}	
	
	public void addAction(TAction action) {
		// TODO Auto-generated method stub
		addAfter(ACTION_PROPERTY, action, TypeCollection.EMPTY.types());
		
	}

	public List<TAction> getActions() {
		// TODO Auto-generated method stub
		return getChildren (TAction.class);
	}

	public void removeAction(TAction action) {
		// TODO Auto-generated method stub
		removeChild(ACTION_PROPERTY, action);
	}

	public void accept(WLMVisitor visitor) {
		// TODO Auto-generated method stub
		visitor.visitNotification(this);
	}

	public WLMComponent createChild(Element childEl) {
		// TODO Auto-generated method stub
		WLMComponent child = null;
		if (childEl != null) {
			String localName = childEl.getLocalName();
			if (localName == null || localName.length() == 0) {
				localName = childEl.getTagName();
			}
			if (localName.equals(ACTION_PROPERTY)) {
				child = new ActionImpl(getModel(), childEl);
			}
		}
		return child;
	}

}
