<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@ page import="org.netbeans.server.uihandler.statistics.ProjectTypes" %>
<%@ page import="java.util.Map" %>
<%@ page import="java.util.Set" %>
<%@ taglib uri="/WEB-INF/chart-tag.tld" prefix="chart" %>
<%@ taglib uri="/WEB-INF/statistics.tld" prefix="ui" %>

<head>
<jsp:include page="../template/header.jsp"/>
<ui:useStatistic name="ProjectSessions"/>

<a href="http://www.netbeans.org/index.html">HOME</a> 
/ 
<a href="http://www.netbeans.org/community/index.html">Community</a>
/
<a href="../index.jsp">Analytics</a>
/
Graphs
/
Project Sessions

</div><td class="valign-top b-right full-width">

    <div class="f-page-cell bg-sky" >
        <h2>Project Types Usage by Session</h2>
        
        <p>
            NetBeans IDE allows people to use many project at once. Indeed,
            sometimes it is OK to use just one project, however in some other
            situations it might be necessary to open more than one at the
            same type. The expectation is that if people work on 
            <a href="http://maven.apache.org">Maven</a> or on 
            <a href="http://apisupport.netbeans.org">NetBeans Module</a>
            projects, they are likely to have more than one project of the
            same type open.
        </p>
        
        <p>
            Whether or not this assumption is true can be checked by
            comparing results of this statistic, which counts every project
            type used during a session just once, with the <a href="projecttypes.jsp">similar
            one</a>, which counts every used project.
        </p>
    </div>
    
    <table width="100%">
        <% 
        if (pageContext.getAttribute("globalProjectSessions") != null) {
        %>
        <tr>
            <td align="center" width="480">
                <chart:pie
                    collection="globalProjectSessions"
                    category="key"
                    value="value"
                    title="History of All Users"
                />
                <p>
                    This is the overall ratio of percentage of usage of individual
                    project types among all the submitted data.
                </p>
            </td>
        </tr>
        <% }
        %>
        <% 
        if (pageContext.getAttribute("userProjectSessions") != null) {
        %>
        <tr>
            <td align="center" width="480">
                <chart:pie
                    collection="userProjectSessions"
                    category="key"
                    value="value"
                    title="All Your Sessions"
                />
                <p>
                    Here is the history of your usage of various projects
                    over all your submitted sessions.
                </p>
            </td>
        </tr>
        <% }
        %>
        <% 
        if (pageContext.getAttribute("lastProjectSessions") != null) {
        %>
        <tr>
            <td align="center" width="480">
                <chart:pie
                    collection="lastProjectSessions"
                    category="key"
                    value="value"
                    title="Your Last Session"
                />
                <p>
                    This is the percentage of project types touched by you during
                    your last session.
                </p>
            </td>
        </tr>
        <% }
        %>
    </table>
    <p>
        
    </p>
        
    <form method="get" action="<% out.print(HttpUtils.getRequestURL(request)); %>" >
        <table width="100%">
           <tr>
               <td colspan="2">Here you can change the minimal percentage usage of a project
                   type. All types used less than this number of percents, 
                    will be included in the overall category 'Others':
               </td>
           </tr>
           <tr>
            <td colspan="2" align="center">Minimal usage of a project type:
            <input size="2" maxlength="2" type="text" name="minimal" value='${minimal!=null?minimal:"5"}'/> %
            </td>
           </tr>
        </table>
    </form>

</center>
<jsp:include page="../template/footer.jsp"/>
