/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.lib.jmi.xmi;

import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Collection;
import javax.jmi.reflect.RefPackage;
import javax.jmi.xmi.MalformedXMIException;
import javax.jmi.xmi.XmiReader;
import javax.xml.parsers.ParserConfigurationException;
import org.netbeans.lib.jmi.util.Logger;
import org.xml.sax.SAXException;

public class XMISaxReaderImpl implements XmiReader {

    /** Creates new XMISaxReaderImpl */
    public XMISaxReaderImpl () {
    }

    public Collection read (InputStream stream, String uri, RefPackage extent) throws IOException, MalformedXMIException {
        // [PENDING] correct this code to throw exceptions correctly
        try {
            // [PENDING] correct this call to use both stream and URI
            return new XmiSAXReader ().read (stream, uri, new RefPackage[] {extent}, null);
        } catch (ParserConfigurationException e) {
            MalformedXMIException ne = new MalformedXMIException(e.getMessage());
            Logger.getDefault().annotate(ne, e);
            throw ne;
        } catch (SAXException e) {
            MalformedXMIException ne = new MalformedXMIException(e.getMessage());
            Logger.getDefault().annotate(ne, e);
            throw ne;
        }
    }
    
    public Collection read (String uri, RefPackage extent) 
    throws IOException, MalformedXMIException {
        return read (new URL(uri), new RefPackage[] {extent}, null);
    }
    
    private Collection read (URL url, RefPackage[] extents, String encoding)
        throws IOException, MalformedXMIException {
        // [PENDING] correct this code to throw exceptions correctly
        try {
            return new XmiSAXReader ().read (url, extents, encoding);
        } catch (ParserConfigurationException e) {
            MalformedXMIException ne = new MalformedXMIException(e.toString());
            Logger.getDefault().annotate(ne, e);
            throw ne;
        } catch (SAXException e) {
            MalformedXMIException ne = new MalformedXMIException(e.toString());
            Logger.getDefault().annotate(ne, e);
            throw ne;
        }
    }
    
}
