/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 */


package org.foo.fftview;

import java.awt.Image;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import org.foo.wavsupport.api.WavViewDescriptor;
import org.netbeans.core.spi.multiview.MultiViewElement;
import org.openide.loaders.DataObject;
import org.openide.util.HelpCtx;
import org.openide.util.Utilities;
import org.openide.windows.TopComponent;

/**
 *
 * @author runger
 */
public class FFTViewDescriptor implements WavViewDescriptor {
    
    private static final long serialVersionUID = 1L;
    
    public static Image ICON = Utilities.loadImage("org/foo/wavutils/sampleGraph.gif");
    
    private DataObject dobj;

    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_ALWAYS;
    }

    public String getDisplayName() {
        return "Frequency Domain";
    }

    public Image getIcon() {
        return ICON;
    }

    public HelpCtx getHelpCtx() {
        return null;
    }

    public String preferredID() {
        return "FFT";
    }

    public MultiViewElement createElement() {
        return new FFTComponent(dobj);
    }

    public void setWavDataObject(DataObject wav) {
        dobj = wav;
    }
 
    private void writeObject(ObjectOutputStream out) throws IOException
    {
        out.defaultWriteObject();
    }
   
}
