/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.examples.modules.minicomposer;

import org.netbeans.spi.looks.DefaultLook;
import org.openide.util.HelpCtx;
import org.openide.util.Lookup;
import org.openide.util.NbBundle;

/**
 * Appearance of the internal player.
 * @author Jesse Glick
 */
public class InternalPlayerLook extends DefaultLook {

    public InternalPlayerLook() {
        super("InternalPlayerLook");
    }

    public String getDisplayName() {
        return NbBundle.getMessage(InternalPlayerLook.class, "LBL_InternalPlayer");
    }

    public String getName(Object o, Lookup l) {
        return "InternalPlayer";
    }
    
    public String getDisplayName(Object o, Lookup l) {
        return NbBundle.getMessage(InternalPlayerLook.class, "LBL_InternalPlayer");
    }
    
    public String getShortDescription(Object o, Lookup l) {
        return NbBundle.getMessage(InternalPlayerLook.class, "HINT_InternalPlayer");
    }
    
    protected String iconBase(Object o, Lookup l) {
        return "org/netbeans/examples/modules/minicomposer/resources/InternalPlayerIcon";
    }
    
    public HelpCtx getHelpCtx(Object o, Lookup l) {
        return new HelpCtx("org.netbeans.examples.modules.minicomposer.playing");
    }
    
    public boolean isLeaf(Object o, Lookup l) {
        // This should be the default: #36293
        return true;
    }
    
}
