/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/
package pluginportal;

import com.sun.j2ee.blueprints.ui.autocomplete.AutoCompleteComponent;
import com.sun.j2ee.blueprints.ui.autocomplete.CompletionResult;
import com.sun.rave.web.ui.appbase.AbstractPageBean;
import com.sun.webui.jsf.component.Body;
import com.sun.webui.jsf.component.Button;
import com.sun.webui.jsf.component.Checkbox;
import com.sun.webui.jsf.component.DropDown;
import com.sun.webui.jsf.component.Form;
import com.sun.webui.jsf.component.Head;
import com.sun.webui.jsf.component.Html;
import com.sun.webui.jsf.component.Hyperlink;
import com.sun.webui.jsf.component.ImageComponent;
import com.sun.webui.jsf.component.ImageHyperlink;
import com.sun.webui.jsf.component.Label;
import com.sun.webui.jsf.component.Link;
import com.sun.webui.jsf.component.Markup;
import com.sun.webui.jsf.component.MessageGroup;
import com.sun.webui.jsf.component.Page;
import com.sun.webui.jsf.component.PanelGroup;
import com.sun.webui.jsf.component.PanelLayout;
import com.sun.webui.jsf.component.Property;
import com.sun.webui.jsf.component.PropertySheet;
import com.sun.webui.jsf.component.PropertySheetSection;
import com.sun.webui.jsf.component.Script;
import com.sun.webui.jsf.component.StaticText;
import com.sun.webui.jsf.component.TextArea;
import com.sun.webui.jsf.component.TextField;
import com.sun.webui.jsf.component.Upload;
import com.sun.webui.jsf.model.MultipleSelectOptionsList;
import com.sun.webui.jsf.model.Option;
import com.sun.webui.jsf.model.SingleSelectOptionsList;
import com.sun.webui.jsf.model.UploadedFile;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.Date;
import javax.faces.FacesException;
import javax.faces.application.FacesMessage;
import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlPanelGrid;
import javax.faces.context.FacesContext;
import javax.faces.convert.LongConverter;
import javax.faces.event.ValueChangeEvent;
import javax.faces.validator.ValidatorException;
import org.netbeans.pluginportal.system.NBMDeploymentDescriptor;
import org.netbeans.pluginportal.system.OtherCategory;
import org.netbeans.pluginportal.system.Plugin;
import org.netbeans.pluginportal.system.PluginException;
import org.netbeans.pluginportal.system.QualityLevel;

/**
 * <p>Page bean that corresponds to a similarly named JSP page.  This
 * class contains component definitions (and initialization code) for
 * all components that you have defined on this page, as well as
 * lifecycle methods and event handlers where you may add behavior
 * to respond to incoming events.</p>
 *
 * @author David Botterill
 */
public class AddPageStep2 extends AbstractPageBean {
    // <editor-fold defaultstate="collapsed" desc="Managed Component Definition">
    private int __placeholder;
    
    /**
     * <p>Automatically managed component initialization.  <strong>WARNING:</strong>
     * This method is automatically generated, so any user-specified code inserted
     * here is subject to being replaced.</p>
     */
    private void _init() throws Exception {
    }
    
    private Page page1 = new Page();
    
    public Page getPage1() {
        return page1;
    }
    
    public void setPage1(Page p) {
        this.page1 = p;
    }
    
    private Html html1 = new Html();
    
    public Html getHtml1() {
        return html1;
    }
    
    public void setHtml1(Html h) {
        this.html1 = h;
    }
    
    private Head head1 = new Head();
    
    public Head getHead1() {
        return head1;
    }
    
    public void setHead1(Head h) {
        this.head1 = h;
    }
    
    private Link link1 = new Link();
    
    public Link getLink1() {
        return link1;
    }
    
    public void setLink1(Link l) {
        this.link1 = l;
    }
    
    private Body body1 = new Body();
    
    public Body getBody1() {
        return body1;
    }
    
    public void setBody1(Body b) {
        this.body1 = b;
    }
    
    private Form form1 = new Form();
    
    public Form getForm1() {
        return form1;
    }
    
    public void setForm1(Form f) {
        this.form1 = f;
    }
    
    private PanelLayout center_container = new PanelLayout();
    
    public PanelLayout getCenter_container() {
        return center_container;
    }
    
    public void setCenter_container(PanelLayout pl) {
        this.center_container = pl;
    }
    
    private PanelLayout page_border = new PanelLayout();
    
    public PanelLayout getPage_border() {
        return page_border;
    }
    
    public void setPage_border(PanelLayout pl) {
        this.page_border = pl;
    }
    
    private PanelLayout fixed_tabs = new PanelLayout();
    
    public PanelLayout getFixed_tabs() {
        return fixed_tabs;
    }
    
    public void setFixed_tabs(PanelLayout pl) {
        this.fixed_tabs = pl;
    }
    
    private ImageComponent image1 = new ImageComponent();
    
    public ImageComponent getImage1() {
        return image1;
    }
    
    public void setImage1(ImageComponent ic) {
        this.image1 = ic;
    }
    
    private ImageComponent image2 = new ImageComponent();
    
    public ImageComponent getImage2() {
        return image2;
    }
    
    public void setImage2(ImageComponent ic) {
        this.image2 = ic;
    }
    
    private ImageHyperlink imageHyperlink1 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink1() {
        return imageHyperlink1;
    }
    
    public void setImageHyperlink1(ImageHyperlink ih) {
        this.imageHyperlink1 = ih;
    }
    
    private ImageHyperlink imageHyperlink2 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink2() {
        return imageHyperlink2;
    }
    
    public void setImageHyperlink2(ImageHyperlink ih) {
        this.imageHyperlink2 = ih;
    }
    
    private ImageHyperlink imageHyperlink3 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink3() {
        return imageHyperlink3;
    }
    
    public void setImageHyperlink3(ImageHyperlink ih) {
        this.imageHyperlink3 = ih;
    }
    
    private ImageHyperlink imageHyperlink4 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink4() {
        return imageHyperlink4;
    }
    
    public void setImageHyperlink4(ImageHyperlink ih) {
        this.imageHyperlink4 = ih;
    }
    
    private ImageHyperlink imageHyperlink5 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink5() {
        return imageHyperlink5;
    }
    
    public void setImageHyperlink5(ImageHyperlink ih) {
        this.imageHyperlink5 = ih;
    }
    
    private ImageHyperlink imageHyperlink6 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink6() {
        return imageHyperlink6;
    }
    
    public void setImageHyperlink6(ImageHyperlink ih) {
        this.imageHyperlink6 = ih;
    }
    
    private PanelLayout fixed_contentarea = new PanelLayout();
    
    public PanelLayout getFixed_contentarea() {
        return fixed_contentarea;
    }
    
    public void setFixed_contentarea(PanelLayout pl) {
        this.fixed_contentarea = pl;
    }
    
    private PanelLayout fixed_contextbox = new PanelLayout();
    
    public PanelLayout getFixed_contextbox() {
        return fixed_contextbox;
    }
    
    public void setFixed_contextbox(PanelLayout pl) {
        this.fixed_contextbox = pl;
    }
    
    private StaticText txtLogon1 = new StaticText();
    
    public StaticText getTxtLogon1() {
        return txtLogon1;
    }
    
    public void setTxtLogon1(StaticText st) {
        this.txtLogon1 = st;
    }
    
    private PanelLayout midPanel = new PanelLayout();
    
    public PanelLayout getMidPanel() {
        return midPanel;
    }
    
    public void setMidPanel(PanelLayout pl) {
        this.midPanel = pl;
    }
    
    private Markup markup3 = new Markup();
    
    public Markup getMarkup3() {
        return markup3;
    }
    
    public void setMarkup3(Markup m) {
        this.markup3 = m;
    }
    
    private StaticText staticText2 = new StaticText();
    
    public StaticText getStaticText2() {
        return staticText2;
    }
    
    public void setStaticText2(StaticText st) {
        this.staticText2 = st;
    }
    
    private PanelLayout fieldPanel = new PanelLayout();
    
    public PanelLayout getFieldPanel() {
        return fieldPanel;
    }
    
    public void setFieldPanel(PanelLayout pl) {
        this.fieldPanel = pl;
    }
    
    private PanelLayout fixed_footer1 = new PanelLayout();
    
    public PanelLayout getFixed_footer1() {
        return fixed_footer1;
    }
    
    public void setFixed_footer1(PanelLayout pl) {
        this.fixed_footer1 = pl;
    }
    
    private PanelLayout footer_text1 = new PanelLayout();
    
    public PanelLayout getFooter_text1() {
        return footer_text1;
    }
    
    public void setFooter_text1(PanelLayout pl) {
        this.footer_text1 = pl;
    }
    
    private PanelLayout footer_navig1 = new PanelLayout();
    
    public PanelLayout getFooter_navig1() {
        return footer_navig1;
    }
    
    public void setFooter_navig1(PanelLayout pl) {
        this.footer_navig1 = pl;
    }
    
    private StaticText staticText3 = new StaticText();
    
    public StaticText getStaticText3() {
        return staticText3;
    }
    
    public void setStaticText3(StaticText st) {
        this.staticText3 = st;
    }
    
    private StaticText staticText4 = new StaticText();
    
    public StaticText getStaticText4() {
        return staticText4;
    }
    
    public void setStaticText4(StaticText st) {
        this.staticText4 = st;
    }
    
    private Hyperlink hyperlink2 = new Hyperlink();
    
    public Hyperlink getHyperlink2() {
        return hyperlink2;
    }
    
    public void setHyperlink2(Hyperlink h) {
        this.hyperlink2 = h;
    }
    
    private StaticText staticText5 = new StaticText();
    
    public StaticText getStaticText5() {
        return staticText5;
    }
    
    public void setStaticText5(StaticText st) {
        this.staticText5 = st;
    }
    
    private Hyperlink hyperlink3 = new Hyperlink();
    
    public Hyperlink getHyperlink3() {
        return hyperlink3;
    }
    
    public void setHyperlink3(Hyperlink h) {
        this.hyperlink3 = h;
    }
    
    private StaticText staticText6 = new StaticText();
    
    public StaticText getStaticText6() {
        return staticText6;
    }
    
    public void setStaticText6(StaticText st) {
        this.staticText6 = st;
    }
    
    private StaticText staticText7 = new StaticText();
    
    public StaticText getStaticText7() {
        return staticText7;
    }
    
    public void setStaticText7(StaticText st) {
        this.staticText7 = st;
    }
    
    private Hyperlink hyperlink4 = new Hyperlink();
    
    public Hyperlink getHyperlink4() {
        return hyperlink4;
    }
    
    public void setHyperlink4(Hyperlink h) {
        this.hyperlink4 = h;
    }
    
    private StaticText staticText8 = new StaticText();
    
    public StaticText getStaticText8() {
        return staticText8;
    }
    
    public void setStaticText8(StaticText st) {
        this.staticText8 = st;
    }
    
    private Hyperlink hyperlink5 = new Hyperlink();
    
    public Hyperlink getHyperlink5() {
        return hyperlink5;
    }
    
    public void setHyperlink5(Hyperlink h) {
        this.hyperlink5 = h;
    }
    
    private StaticText staticText9 = new StaticText();
    
    public StaticText getStaticText9() {
        return staticText9;
    }
    
    public void setStaticText9(StaticText st) {
        this.staticText9 = st;
    }
    
    private Hyperlink hyperlink6 = new Hyperlink();
    
    public Hyperlink getHyperlink6() {
        return hyperlink6;
    }
    
    public void setHyperlink6(Hyperlink h) {
        this.hyperlink6 = h;
    }
    
    private PanelLayout tof1 = new PanelLayout();
    
    public PanelLayout getTof1() {
        return tof1;
    }
    
    public void setTof1(PanelLayout pl) {
        this.tof1 = pl;
    }
    
    private StaticText staticText10 = new StaticText();
    
    public StaticText getStaticText10() {
        return staticText10;
    }
    
    public void setStaticText10(StaticText st) {
        this.staticText10 = st;
    }
    
    private Hyperlink hyperlink7 = new Hyperlink();
    
    public Hyperlink getHyperlink7() {
        return hyperlink7;
    }
    
    public void setHyperlink7(Hyperlink h) {
        this.hyperlink7 = h;
    }
    
    private AutoCompleteComponent txtOtherCategories = new AutoCompleteComponent();
    
    public AutoCompleteComponent getTxtOtherCategories() {
        return txtOtherCategories;
    }
    
    public void setTxtOtherCategories(AutoCompleteComponent acc) {
        this.txtOtherCategories = acc;
    }
    
    private Label label6 = new Label();
    
    public Label getLabel6() {
        return label6;
    }
    
    public void setLabel6(Label l) {
        this.label6 = l;
    }
    
    private Markup markup14 = new Markup();
    
    public Markup getMarkup14() {
        return markup14;
    }
    
    public void setMarkup14(Markup m) {
        this.markup14 = m;
    }
    
    private TextArea txtSummary = new TextArea();
    
    public TextArea getTxtSummary() {
        return txtSummary;
    }
    
    public void setTxtSummary(TextArea ta) {
        this.txtSummary = ta;
    }
    
    private PanelLayout bottomPanel = new PanelLayout();
    
    public PanelLayout getBottomPanel() {
        return bottomPanel;
    }
    
    public void setBottomPanel(PanelLayout pl) {
        this.bottomPanel = pl;
    }
    
    private Upload txtImageFileUpload = new Upload();
    
    public Upload getTxtImageFileUpload() {
        return txtImageFileUpload;
    }
    
    public void setTxtImageFileUpload(Upload u) {
        this.txtImageFileUpload = u;
    }
    
    private Markup markup13 = new Markup();
    
    public Markup getMarkup13() {
        return markup13;
    }
    
    public void setMarkup13(Markup m) {
        this.markup13 = m;
    }
    
    private Label label10 = new Label();
    
    public Label getLabel10() {
        return label10;
    }
    
    public void setLabel10(Label l) {
        this.label10 = l;
    }
    
    private Markup markup19 = new Markup();
    
    public Markup getMarkup19() {
        return markup19;
    }
    
    public void setMarkup19(Markup m) {
        this.markup19 = m;
    }
    
    private TextArea txtDescription = new TextArea();
    
    public TextArea getTxtDescription() {
        return txtDescription;
    }
    
    public void setTxtDescription(TextArea ta) {
        this.txtDescription = ta;
    }
    
    private Button btnFinish = new Button();
    
    public Button getBtnFinish() {
        return btnFinish;
    }
    
    public void setBtnFinish(Button b) {
        this.btnFinish = b;
    }
    
    private Markup markup20 = new Markup();
    
    public Markup getMarkup20() {
        return markup20;
    }
    
    public void setMarkup20(Markup m) {
        this.markup20 = m;
    }
    
    private Markup markup23 = new Markup();
    
    public Markup getMarkup23() {
        return markup23;
    }
    
    public void setMarkup23(Markup m) {
        this.markup23 = m;
    }
    
    private Markup markup27 = new Markup();
    
    public Markup getMarkup27() {
        return markup27;
    }
    
    public void setMarkup27(Markup m) {
        this.markup27 = m;
    }
    
    private MessageGroup messageGroup1 = new MessageGroup();
    
    public MessageGroup getMessageGroup1() {
        return messageGroup1;
    }
    
    public void setMessageGroup1(MessageGroup mg) {
        this.messageGroup1 = mg;
    }
    
    private LongConverter longConverter1 = new LongConverter();
    
    public LongConverter getLongConverter1() {
        return longConverter1;
    }
    
    public void setLongConverter1(LongConverter lc) {
        this.longConverter1 = lc;
    }
    
    private Button btnCancel = new Button();
    
    public Button getBtnCancel() {
        return btnCancel;
    }
    
    public void setBtnCancel(Button b) {
        this.btnCancel = b;
    }
    
    private PanelGroup buttonPanel = new PanelGroup();
    
    public PanelGroup getButtonPanel() {
        return buttonPanel;
    }
    
    public void setButtonPanel(PanelGroup pg) {
        this.buttonPanel = pg;
    }
    
    private Script script1 = new Script();
    
    public Script getScript1() {
        return script1;
    }
    
    public void setScript1(Script s) {
        this.script1 = s;
    }
    
    private Markup markup1 = new Markup();
    
    public Markup getMarkup1() {
        return markup1;
    }
    
    public void setMarkup1(Markup m) {
        this.markup1 = m;
    }
    
    private Markup markup2 = new Markup();
    
    public Markup getMarkup2() {
        return markup2;
    }
    
    public void setMarkup2(Markup m) {
        this.markup2 = m;
    }
    
    private Markup markup5 = new Markup();
    
    public Markup getMarkup5() {
        return markup5;
    }
    
    public void setMarkup5(Markup m) {
        this.markup5 = m;
    }
    
    private Markup markup6 = new Markup();
    
    public Markup getMarkup6() {
        return markup6;
    }
    
    public void setMarkup6(Markup m) {
        this.markup6 = m;
    }
    
    private Label label1 = new Label();
    
    public Label getLabel1() {
        return label1;
    }
    
    public void setLabel1(Label l) {
        this.label1 = l;
    }
    
    private PanelLayout otherCategoryPanel = new PanelLayout();
    
    public PanelLayout getOtherCategoryPanel() {
        return otherCategoryPanel;
    }
    
    public void setOtherCategoryPanel(PanelLayout pl) {
        this.otherCategoryPanel = pl;
    }
    
    private StaticText staticText12 = new StaticText();
    
    public StaticText getStaticText12() {
        return staticText12;
    }
    
    public void setStaticText12(StaticText st) {
        this.staticText12 = st;
    }
    
    private Markup markup8 = new Markup();
    
    public Markup getMarkup8() {
        return markup8;
    }
    
    public void setMarkup8(Markup m) {
        this.markup8 = m;
    }
    
    private Markup markup4 = new Markup();
    
    public Markup getMarkup4() {
        return markup4;
    }
    
    public void setMarkup4(Markup m) {
        this.markup4 = m;
    }
    
    private PanelLayout categorizePanel = new PanelLayout();
    
    public PanelLayout getCategorizePanel() {
        return categorizePanel;
    }
    
    public void setCategorizePanel(PanelLayout pl) {
        this.categorizePanel = pl;
    }
    
    private StaticText staticText13 = new StaticText();
    
    public StaticText getStaticText13() {
        return staticText13;
    }
    
    public void setStaticText13(StaticText st) {
        this.staticText13 = st;
    }
    
    private Markup markup12 = new Markup();
    
    public Markup getMarkup12() {
        return markup12;
    }
    
    public void setMarkup12(Markup m) {
        this.markup12 = m;
    }
    
    private Markup markup16 = new Markup();
    
    public Markup getMarkup16() {
        return markup16;
    }
    
    public void setMarkup16(Markup m) {
        this.markup16 = m;
    }
    
    private PanelLayout imagePanel = new PanelLayout();
    
    public PanelLayout getImagePanel() {
        return imagePanel;
    }
    
    public void setImagePanel(PanelLayout pl) {
        this.imagePanel = pl;
    }
    
    private StaticText staticText14 = new StaticText();
    
    public StaticText getStaticText14() {
        return staticText14;
    }
    
    public void setStaticText14(StaticText st) {
        this.staticText14 = st;
    }
    
    private Markup markup17 = new Markup();
    
    public Markup getMarkup17() {
        return markup17;
    }
    
    public void setMarkup17(Markup m) {
        this.markup17 = m;
    }
    
    private StaticText staticText15 = new StaticText();
    
    public StaticText getStaticText15() {
        return staticText15;
    }
    
    public void setStaticText15(StaticText st) {
        this.staticText15 = st;
    }
    
    private Markup markup18 = new Markup();
    
    public Markup getMarkup18() {
        return markup18;
    }
    
    public void setMarkup18(Markup m) {
        this.markup18 = m;
    }
    
    private Upload txtFullSizeImage = new Upload();
    
    public Upload getTxtFullSizeImage() {
        return txtFullSizeImage;
    }
    
    public void setTxtFullSizeImage(Upload u) {
        this.txtFullSizeImage = u;
    }
    
    private Markup markup21 = new Markup();
    
    public Markup getMarkup21() {
        return markup21;
    }
    
    public void setMarkup21(Markup m) {
        this.markup21 = m;
    }
    
    private StaticText staticText16 = new StaticText();
    
    public StaticText getStaticText16() {
        return staticText16;
    }
    
    public void setStaticText16(StaticText st) {
        this.staticText16 = st;
    }
    
    private Markup markup22 = new Markup();
    
    public Markup getMarkup22() {
        return markup22;
    }
    
    public void setMarkup22(Markup m) {
        this.markup22 = m;
    }
    
    private PanelLayout navig_breadcrumbs = new PanelLayout();
    
    public PanelLayout getNavig_breadcrumbs() {
        return navig_breadcrumbs;
    }
    
    public void setNavig_breadcrumbs(PanelLayout pl) {
        this.navig_breadcrumbs = pl;
    }
    
    private Hyperlink hyperlink1 = new Hyperlink();
    
    public Hyperlink getHyperlink1() {
        return hyperlink1;
    }
    
    public void setHyperlink1(Hyperlink h) {
        this.hyperlink1 = h;
    }
    
    private StaticText staticText17 = new StaticText();
    
    public StaticText getStaticText17() {
        return staticText17;
    }
    
    public void setStaticText17(StaticText st) {
        this.staticText17 = st;
    }
    
    private PanelGroup loginPanel1 = new PanelGroup();
    
    public PanelGroup getLoginPanel1() {
        return loginPanel1;
    }
    
    public void setLoginPanel1(PanelGroup pg) {
        this.loginPanel1 = pg;
    }
    
    private StaticText staticText18 = new StaticText();
    
    public StaticText getStaticText18() {
        return staticText18;
    }
    
    public void setStaticText18(StaticText st) {
        this.staticText18 = st;
    }
    
    private Hyperlink currentUser1 = new Hyperlink();
    
    public Hyperlink getCurrentUser1() {
        return currentUser1;
    }
    
    public void setCurrentUser1(Hyperlink h) {
        this.currentUser1 = h;
    }
    
    private Hyperlink txtLoginLogoff1 = new Hyperlink();
    
    public Hyperlink getTxtLoginLogoff1() {
        return txtLoginLogoff1;
    }
    
    public void setTxtLoginLogoff1(Hyperlink h) {
        this.txtLoginLogoff1 = h;
    }
    
    private HtmlPanelGrid gridPanel1 = new HtmlPanelGrid();
    
    public HtmlPanelGrid getGridPanel1() {
        return gridPanel1;
    }
    
    public void setGridPanel1(HtmlPanelGrid hpg) {
        this.gridPanel1 = hpg;
    }
    
    private Label label2 = new Label();
    
    public Label getLabel2() {
        return label2;
    }
    
    public void setLabel2(Label l) {
        this.label2 = l;
    }
    
    private Label label3 = new Label();
    
    public Label getLabel3() {
        return label3;
    }
    
    public void setLabel3(Label l) {
        this.label3 = l;
    }
    
    private PropertySheet propertySheet1 = new PropertySheet();
    
    public PropertySheet getPropertySheet1() {
        return propertySheet1;
    }
    
    public void setPropertySheet1(PropertySheet ps) {
        this.propertySheet1 = ps;
    }
    
    private PropertySheetSection section1 = new PropertySheetSection();
    
    public PropertySheetSection getSection1() {
        return section1;
    }
    
    public void setSection1(PropertySheetSection pss) {
        this.section1 = pss;
    }
    
    private Property name = new Property();
    
    public Property getName() {
        return name;
    }
    
    public void setName(Property p) {
        this.name = p;
    }
    
    private TextField txtPluginName = new TextField();
    
    public TextField getTxtPluginName() {
        return txtPluginName;
    }
    
    public void setTxtPluginName(TextField tf) {
        this.txtPluginName = tf;
    }
    
    private Property licenseType = new Property();
    
    public Property getLicenseType() {
        return licenseType;
    }
    
    public void setLicenseType(Property p) {
        this.licenseType = p;
    }
    
    private TextField txtLicenseType = new TextField();
    
    public TextField getTxtLicenseType() {
        return txtLicenseType;
    }
    
    public void setTxtLicenseType(TextField tf) {
        this.txtLicenseType = tf;
    }
    
    private Property homePage = new Property();
    
    public Property getHomePage() {
        return homePage;
    }
    
    public void setHomePage(Property p) {
        this.homePage = p;
    }
    
    private TextField txtHomePage = new TextField();
    
    public TextField getTxtHomePage() {
        return txtHomePage;
    }
    
    public void setTxtHomePage(TextField tf) {
        this.txtHomePage = tf;
    }
    
    private Property price = new Property();
    
    public Property getPrice() {
        return price;
    }
    
    public void setPrice(Property p) {
        this.price = p;
    }
    
    private TextField txtPrice = new TextField();
    
    public TextField getTxtPrice() {
        return txtPrice;
    }
    
    public void setTxtPrice(TextField tf) {
        this.txtPrice = tf;
    }
    
    private Property searchKeywords = new Property();
    
    public Property getSearchKeywords() {
        return searchKeywords;
    }
    
    public void setSearchKeywords(Property p) {
        this.searchKeywords = p;
    }
    
    private TextField txtKeywords = new TextField();
    
    public TextField getTxtKeywords() {
        return txtKeywords;
    }
    
    public void setTxtKeywords(TextField tf) {
        this.txtKeywords = tf;
    }
    
    private Property targetPlatforms = new Property();
    
    public Property getTargetPlatforms() {
        return targetPlatforms;
    }
    
    public void setTargetPlatforms(Property p) {
        this.targetPlatforms = p;
    }
    
    private Property versionsSupported = new Property();
    
    public Property getVersionsSupported() {
        return versionsSupported;
    }
    
    public void setVersionsSupported(Property p) {
        this.versionsSupported = p;
    }
    
    private Checkbox chkSolaris = new Checkbox();
    
    public Checkbox getChkSolaris() {
        return chkSolaris;
    }
    
    public void setChkSolaris(Checkbox c) {
        this.chkSolaris = c;
    }
    
    private MultipleSelectOptionsList chkBoxGroupDefaultOptions = new MultipleSelectOptionsList();
    
    public MultipleSelectOptionsList getChkBoxGroupDefaultOptions() {
        return chkBoxGroupDefaultOptions;
    }
    
    public void setChkBoxGroupDefaultOptions(MultipleSelectOptionsList msol) {
        this.chkBoxGroupDefaultOptions = msol;
    }
    
    private Checkbox chkLinux = new Checkbox();
    
    public Checkbox getChkLinux() {
        return chkLinux;
    }
    
    public void setChkLinux(Checkbox c) {
        this.chkLinux = c;
    }
    
    private Checkbox chkMacOSX = new Checkbox();
    
    public Checkbox getChkMacOSX() {
        return chkMacOSX;
    }
    
    public void setChkMacOSX(Checkbox c) {
        this.chkMacOSX = c;
    }
    
    private Checkbox chkWindows = new Checkbox();
    
    public Checkbox getChkWindows() {
        return chkWindows;
    }
    
    public void setChkWindows(Checkbox c) {
        this.chkWindows = c;
    }
    
    private ImageHyperlink imageHyperlink7 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink7() {
        return imageHyperlink7;
    }
    
    public void setImageHyperlink7(ImageHyperlink ih) {
        this.imageHyperlink7 = ih;
    }
    
    private StaticText staticText1 = new StaticText();
    
    public StaticText getStaticText1() {
        return staticText1;
    }
    
    public void setStaticText1(StaticText st) {
        this.staticText1 = st;
    }
    
    private StaticText staticText19 = new StaticText();
    
    public StaticText getStaticText19() {
        return staticText19;
    }
    
    public void setStaticText19(StaticText st) {
        this.staticText19 = st;
    }

    private TextField txtVersionsSupported = new TextField();

    public TextField getTxtVersionsSupported() {
        return txtVersionsSupported;
    }

    public void setTxtVersionsSupported(TextField tf) {
        this.txtVersionsSupported = tf;
    }
    
    
    // </editor-fold>
    
    /**
     * <p>Construct a new Page bean instance.</p>
     */
    public AddPageStep2() {
    }
    
    /**
     * <p>Callback method that is called whenever a page is navigated to,
     * either directly via a URL, or indirectly via page navigation.
     * Customize this method to acquire resources that will be needed
     * for event handlers and lifecycle methods, whether or not this
     * page is performing post back processing.</p>
     *
     * <p>Note that, if the current request is a postback, the property
     * values of the components do <strong>not</strong> represent any
     * values submitted with this request.  Instead, they represent the
     * property values that were saved for this view when it was rendered.</p>
     */
    public void init() {
        // Perform initializations inherited from our superclass
        super.init();
        // Perform application initialization that must complete
        // *before* managed components are initialized
        // TODO - add your own initialiation code here
        
        // <editor-fold defaultstate="collapsed" desc="Managed Component Initialization">
        // Initialize automatically managed components
        // *Note* - this logic should NOT be modified
        try {
            _init();
        } catch (Exception e) {
            log("AddPageStep2 Initialization Failure", e);
            throw e instanceof FacesException ? (FacesException) e: new FacesException(e);
        }
        
        // </editor-fold>
        // Perform application initialization that must complete
        // *after* managed components are initialized
        // TODO - add your own initialization code here
        
        
    }
    
    /**
     * <p>Callback method that is called after the component tree has been
     * restored, but before any event processing takes place.  This method
     * will <strong>only</strong> be called on a postback request that
     * is processing a form submit.  Customize this method to allocate
     * resources that will be required in your event handlers.</p>
     */
    public void preprocess() {
    }
    
    /**
     * <p>Callback method that is called just before rendering takes place.
     * This method will <strong>only</strong> be called for the page that
     * will actually be rendered (and not, for example, on a page that
     * handled a postback and then navigated to a different page).  Customize
     * this method to allocate resources that will be required for rendering
     * this page.</p>
     */
    public void prerender() {
        /**
         * If there is a display category on the request bean, set the selected value
         */
        NBMDeploymentDescriptor dd = this.getSessionBean1().getCurrentNBMDD();
        if(null != dd ) {
            if(null != dd.getOpenide_display_category() && !dd.getOpenide_display_category().equals("")) {
                this.setSelectedDisplayCategory(dd.getOpenide_display_category());
            }
            this.txtPluginName.setText(dd.getOpenide_name());
            this.txtDescription.setText(dd.getOpenide_long_desc());
            this.txtHomePage.setText(dd.getHomepage());
            this.txtSummary.setText(dd.getOpenide_short_desc());
        } 
        
        if(getSessionBean1().getNbmFileSize() == 0){
            /**
             * If there wasn't a file uploaded, we need to make the home page URL 
             * required so we can forward a download request.
             */
            txtHomePage.setRequired(true);
        }
        
        Option [] allOptions = getSessionBean1().getListTargetPlatformDefaultOptions().getOptions();
        ArrayList<String> options = new ArrayList();
        for(int ii=0; null != allOptions && ii < allOptions.length;ii++) {
            options.add((String)allOptions[ii].getValue());
        }
        getSessionBean1().getListTargetPlatformDefaultOptions().setSelectedValue((String [])options.toArray(new String[0]));
        
    }
    
    /**
     * <p>Callback method that is called after rendering is completed for
     * this request, if <code>init()</code> was called (regardless of whether
     * or not this was the page that was actually rendered).  Customize this
     * method to release resources acquired in the <code>init()</code>,
     * <code>preprocess()</code>, or <code>prerender()</code> methods (or
     * acquired during execution of an event handler).</p>
     */
    public void destroy() {
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected ApplicationBean1 getApplicationBean1() {
        return (ApplicationBean1)getBean("ApplicationBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected SessionBean1 getSessionBean1() {
        return (SessionBean1)getBean("SessionBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected RequestBean1 getRequestBean1() {
        return (RequestBean1)getBean("RequestBean1");
    }
    
    /**
     * Holds value of property selectedDisplayCategory.
     */
    private String selectedDisplayCategory;
    
    /**
     * Getter for property selectedDisplayCategory.
     * @return Value of property selectedDisplayCategory.
     */
    public String getSelectedDisplayCategory() {
        return this.selectedDisplayCategory;
    }
    
    /**
     * Setter for property selectedDisplayCategory.
     * @param selectedDisplayCategory New value of property selectedDisplayCategory.
     */
    public void setSelectedDisplayCategory(String selectedDisplayCategory) {
        this.selectedDisplayCategory = selectedDisplayCategory;
    }
    
    public String btnFinish_action() {
        
        if(null != this.txtImageFileUpload &&
                null != this.txtImageFileUpload.getUploadedFile()) {
            long fileSize = this.txtImageFileUpload.getUploadedFile().getSize();
            if(fileSize > (1024L*1024L)) {
                error("Thumbnail image file size is too large:" + fileSize + ". Max is 1MB");
                return null;
            }
        }
        
        if(null != this.txtFullSizeImage &&
                null != this.txtFullSizeImage.getUploadedFile()) {
            long fileSize = this.txtFullSizeImage.getUploadedFile().getSize();
            if(fileSize > (1024L*1024L)) {
                error("Full size image file size is too large:" + fileSize + ". Max is 1MB");
                return null;
            }
        }
        
        /**
         * Add the plugin record
         */
        
        Plugin newPlugin = this.getApplicationBean1().getPluginSystem().createPlugin();
        newPlugin.setAuthor_userid(this.getSessionBean1().getCurrentUserId());
        newPlugin.setDate_added(new Date());
        newPlugin.setDescription((String)txtDescription.getText());
        newPlugin.setHome_page_url((String)txtHomePage.getText());
        newPlugin.setKeywords((String)txtKeywords.getText());
        newPlugin.setLicense_type((String)txtLicenseType.getText());
        if(null != this.getSessionBean1().getCurrentNbmFileName()) {
            newPlugin.setNbm_filename(this.getSessionBean1().getCurrentNbmFileName());
        }
        newPlugin.setPlugin_name((String)txtPluginName.getText());
        newPlugin.setQuality_level(QualityLevel.ALPHA.toString());
        newPlugin.setSummary((String)txtSummary.getText());
        newPlugin.setAverage_rating(0.0);
        newPlugin.setDownloads(0L);
        newPlugin.setDownload_size(new Long(getSessionBean1().getNbmFileSize()));
        newPlugin.setPrice((String)txtPrice.getText());
        /**
         * If there is an NBM file for this plugin, set the spec version and the display category
         */
        if(null != getSessionBean1().getCurrentNBMDD()) {
            newPlugin.setVersion(getSessionBean1().getCurrentNBMDD().getOpenide_module_spec_version());
            newPlugin.setDisplaycategory(getSessionBean1().getCurrentNBMDD().getOpenide_display_category());
        }
        /**
         * supported versions
         */
        
        newPlugin.setVersions_supported((String)txtVersionsSupported.getText());
        /**
         * Target Platforms.
         */
        
        String allSelected="";
        if(null != chkSolaris && chkSolaris.isChecked()) {
            allSelected += chkSolaris.getSelectedValue().toString() + ",";
        }
        if(null != chkLinux && chkLinux.isChecked()) {
            allSelected += chkLinux.getSelectedValue().toString() + ",";
        }
        if(null != chkMacOSX && chkMacOSX.isChecked()) {
            allSelected += chkMacOSX.getSelectedValue().toString() + ",";
        }
        if(null != chkWindows && chkWindows.isChecked()) {
            allSelected += chkWindows.getSelectedValue().toString() + ",";
        }
        newPlugin.setTarget_platforms(allSelected);
        
        if(null != txtImageFileUpload &&
                null != this.txtImageFileUpload.getUploadedFile() &&
                null != this.txtImageFileUpload.getUploadedFile().getOriginalName() &&
                !this.txtImageFileUpload.getUploadedFile().getOriginalName().equals("")) {
            
            String imageFilename = "";
            try {
                imageFilename = FileUtils.getImageFile(this.txtImageFileUpload.getUploadedFile());
            } catch (Exception ex) {
                log("Error Adding module",ex);
                error("Error adding Module!\n" + ex.getMessage());
                return null;
            }
            newPlugin.setImage_filename(imageFilename);
        }
        
        if(null != this.txtFullSizeImage &&
                null != this.txtFullSizeImage.getUploadedFile() &&
                null != this.txtFullSizeImage.getUploadedFile().getOriginalName() &&
                !this.txtFullSizeImage.getUploadedFile().getOriginalName().equals("")) {
            String imageFilename = "";
            try {
                imageFilename = FileUtils.getImageFile(this.txtFullSizeImage.getUploadedFile());
            } catch (Exception ex) {
                log("Error Adding module",ex);
                error("Error adding Module!\n" + ex.getMessage());
                return null;
            }
            newPlugin.setFullsize_image_filename(imageFilename);
        }
        
        Plugin managedPlugin = null;
        try {
            managedPlugin = this.getApplicationBean1().getPluginSystem().addPlugin(newPlugin,getSessionBean1().getAuthToken(),getSessionBean1().getCurrentUserId());
        } catch (PluginException ex) {
            log("Error Adding module",ex);
            error("Error adding Module!\n" + ex.getMessage());
            return null;
        }
        
        
        
        /**
         * Now add the other categories
         */
        String allOtherCategories = (String)txtOtherCategories.getText();
        if(null != allOtherCategories && !allOtherCategories.equals("")) {
            String [] potentialCategories = allOtherCategories.split(",");
            if(null != potentialCategories) {
                OtherCategory newOtherCategory = null;
                for(int ii=0; null != potentialCategories && ii < potentialCategories.length; ii++) {
                    newOtherCategory = this.getApplicationBean1().getPluginSystem().createOtherCategory();
                    newOtherCategory.setCategoryname(potentialCategories[ii]);
                    try {
                        this.getApplicationBean1().getPluginSystem().addOtherCategory(managedPlugin,newOtherCategory,getSessionBean1().getAuthToken(),getSessionBean1().getCurrentUserId());
                    } catch (PluginException ex) {
                        log("Error Adding module",ex);
                        error("Error adding Module!\n" + ex.getMessage());
                        return null;
                        
                    }
                }
            }
        }
        
        
        return "myplugins";
    }
    
    
    
    public String btnCancel_action() {
        
        return "home";
    }
    
    public void txtOtherCategories_complete(FacesContext context, String prefix, CompletionResult result) {
        String save_prefix = prefix;
        
        /**
         * break apart on "," (%2C = ,)
         */
        if(prefix.indexOf("%2C") != -1) {
            prefix = prefix.substring(prefix.lastIndexOf("%2C")+3);
        }
        String [] matchCategories = getApplicationBean1().getPluginSystem().matchOtherCategoryPrefix(prefix);
        
        result.addItems(matchCategories);
    }
    
    public String lnkHome_action() {
        
        return "home";
    }
    
    /**
     * Holds value of property selectedDevelopedWith.
     */
    private String selectedDevelopedWith;
    
    /**
     * Getter for property selectedDevelopedWith.
     * @return Value of property selectedDevelopedWith.
     */
    public String getSelectedDevelopedWith() {
        return this.selectedDevelopedWith;
    }
    
    /**
     * Setter for property selectedDevelopedWith.
     * @param selectedDevelopedWith New value of property selectedDevelopedWith.
     */
    public void setSelectedDevelopedWith(String selectedDevelopedWith) {
        this.selectedDevelopedWith = selectedDevelopedWith;
    }
    
    
    public void txtPluginName_validate(FacesContext context, UIComponent component, Object value) {
        Plugin plugin = getApplicationBean1().getPluginSystem().getPluginByName((String)value);
        if(null != plugin) {
            throw new ValidatorException(new FacesMessage("A plugin with this name already exists! Please choose a different name."));
        }
        
    }
    
    public void txtOtherCategories_validate(FacesContext context, UIComponent component, Object value) {
        
        
    }
    
    public String hyperlink1_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String currentUser_action() {
        return "myplugins";
    }
    
    public String txtLoginLogoff_action() {
        if(this.getSessionBean1().isLoggedIn()) {
            this.getSessionBean1().logoff();
            return "home";
        } else {
            this.getSessionBean1().setReturnFromLoginPage("home");
            return "login";
        }
    }
    
    public void txtHomePage_processValueChange(ValueChangeEvent event) {
        // TODO: Replace with your code
        
    }
    
    public void txtKeywords1_processValueChange(ValueChangeEvent event) {
        // TODO: Replace with your code
        
    }
    
    /**
     * Holds value of property selectedTargetPlatforms.
     */
    private String[] selectedTargetPlatforms;
    
    /**
     * Getter for property selectedTargetPlatforms.
     * @return Value of property selectedTargetPlatforms.
     */
    public String[] getSelectedTargetPlatforms() {
        return this.selectedTargetPlatforms;
    }
    
    /**
     * Setter for property selectedTargetPlatforms.
     * @param selectedTargetPlatforms New value of property selectedTargetPlatforms.
     */
    public void setSelectedTargetPlatforms(String[] selectedTargetPlatforms) {
        this.selectedTargetPlatforms = selectedTargetPlatforms;
    }
    
    public void imageFile_validate(FacesContext context, UIComponent component, Object value) {
        
        UploadedFile upload = (UploadedFile)value;
        String fileName = upload.getOriginalName();
        if(null != fileName && !fileName.equals("")) {
            if(fileName.lastIndexOf(".") == -1) {
                throw new ValidatorException(new FacesMessage("Invalid file type! You must point to a .jpeg,.jpg,.png, or .gif file."));
            }
            String fileType = fileName.substring(fileName.lastIndexOf("."));
            if(!fileType.equalsIgnoreCase(".JPEG") &&
                    !fileType.equalsIgnoreCase(".JPG") &&
                    !fileType.equalsIgnoreCase(".PNG") &&
                    !fileType.equalsIgnoreCase(".GIF")) {
                throw new ValidatorException(new FacesMessage("Invalid file type! You must point to a .jpeg,.jpg,.png, or .gif file."));
            }
        }
        
        
    }
    
    public void txtHomePage_validate(FacesContext context, UIComponent component, Object value) {
        String homePage = null;
        
        if(null == value) {
            return;
        }
        
        homePage = (String)value;
        
        try {
            URL homePageURL = new URL(homePage);
        } catch(MalformedURLException mfue) {
            throw new ValidatorException(new FacesMessage("Invalid URL Specified!"));
        }
        
    }
    
}

