/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/

package org.netbeans.pluginportal.data;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import org.netbeans.pluginportal.system.DisplayCategory;

/**
 * Entity class DisplayCategoryImpl
 *
 *
 * @author David Botterill
 */
@Entity
public class DisplayCategoryImpl implements Serializable, DisplayCategory {
    
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private int id;
    
    /**
     * Creates a new instance of DisplayCategoryImpl
     */
    public DisplayCategoryImpl() {
    }
    
    /**
     * Gets the id of this DisplayCategoryImpl.
     *
     * @return the id
     */
    public int getId() {
        return this.id;
    }
    
    /**
     * Sets the id of this DisplayCategoryImpl to the specified value.
     *
     * @param id the new id
     */
    public void setId(int id) {
        this.id = id;
    }
    
    /**
     * Returns a hash code value for the object.  This implementation computes
     * a hash code value based on the id fields in this object.
     * @return a hash code value for this object.
     */
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != -1 ? (new Integer(this.id)).hashCode() : 0);
        return hash;
    }
    
    /**
     * Determines whether another object is equal to this DisplayCategoryImpl.  The result is
     * <code>true</code> if and only if the argument is not null and is a DisplayCategoryImpl object that
     * has the same id field values as this object.
     *
     * @param object the reference object with which to compare
     * @return <code>true</code> if this object is the same as the argument;
     * <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DisplayCategoryImpl)) {
            return false;
        }
        DisplayCategoryImpl other = (DisplayCategoryImpl)object;
        if (this.id != other.id) return false;
        return true;
    }
    
    /**
     * Returns a string representation of the object.  This implementation constructs
     * that representation based on the id fields.
     * @return a string representation of the object.
     */
    @Override
    public String toString() {
        return "org.netbeans.pluginportal.data.DisplayCategory[id=" + id + "]";
    }
    
    /**
     * Holds value of property displaycategory_name.
     */
    private String displaycategory_name;
    
    /**
     * Getter for property displaycategory_name.
     * @return Value of property displaycategory_name.
     */
    public String getDisplaycategory_name() {
        return this.displaycategory_name;
    }
    
    /**
     * Setter for property displaycategory_name.
     * @param displaycategory_name New value of property displaycategory_name.
     */
    public void setDisplaycategory_name(String displaycategory_name) {
        this.displaycategory_name = displaycategory_name;
    }
    
}
