/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.iz;


import java.util.*;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;
import org.netbeans.iz.Query;

/**
 *
 * @author  jchalupa
 */
public class QuerySet {
    
    private Vector querySet;
    private Hashtable params = new Hashtable();
    private String name;
    
    /** Creates a new instance of QuerySet */
    public QuerySet() {
        querySet = new Vector();
    }
    
    
    public void addQuery(Query query) {
        querySet.add(query);
    }
    
    
    public List execute() throws IOException {
        
        List product = new ArrayList();
        
        Enumeration en = querySet.elements();
        while (en.hasMoreElements()) {
            // execute the next query
            List lst = ((Query)en.nextElement()).execute();
            // merge the results (eliminate duplicate ids)
            ListIterator it = lst.listIterator();
            while (it.hasNext()) {
                Object elem = it.next();
                if (!product.contains(elem)) {
                    product.add(elem);
                }
            }
        }
        
        return product;
    }

    
    public void setName(String name) {
        this.name = name;
    }
    
    public String getName() {
        return this.name;
    }
    
    
    public void setParam(String name, String value) {
        params.put(name, value);
    }

    
    public String getParam(String name) {
        return (String)params.get(name);
    }
    
    
    public Enumeration getParamNames() {
        return params.keys();
    }
        
}
