/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.qa.qreporter;

/**
 *
 * @author  mk97936
 */
public class IssueInfo extends Object {
        
    public static final int PRIORITY = 0;
    public static final int TYPE = 1;
    public static final int DESCRIPTION = 2;
    public static final int STATUS = 3;
    public static final int COMPONENT = 4;
    public static final int ASSIGNED = 5;
    public static final int SUBCOMPONENT = 6;
    public static final int KEYWORD = 7;
    public static final int RESOLUTION = 8;
    
    public String issue_id;
    public String priority;
    public String type;
    public String description;
    public String status;
    public String component;
    public String assigned_to;
    public String subcomponent;
    public String keyword;
    public String resolution;
    
    public IssueInfo(String issid, String prio, String typ, String desc, 
                     String stat, String comp, String assign, String subcomp, 
                     String kword, String res) {
                         
        issue_id = issid;
        priority = prio;
        type = typ;
        description = desc;
        status = stat;
        component = comp;
        assigned_to = assign;
        subcomponent = subcomp;
        keyword = kword;
        resolution = res;
        
    }
    
    public IssueInfo(IssueInfo iss) {
        this.issue_id = iss.issue_id;
        this.priority = iss.priority;
        this.type = iss.type;
        this.description = iss.description;
        this.status = iss.status;
        this.component = iss.component;
        this.assigned_to = iss.assigned_to;
        this.subcomponent = iss.subcomponent;
        this.keyword = iss.keyword;
        this.resolution = iss.resolution;
    }
    
    public boolean equals(Object obj) {
        if ( (obj instanceof IssueInfo) && this.issue_id.equals(((IssueInfo) obj).issue_id) ) {
            return true;
        }
        return false;
    }
    
    public int hashCode() {
        return issue_id.hashCode();
    }
    
}
