/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.errors;

import java.awt.*;
import java.awt.datatransfer.*;
import java.io.*;
import javax.swing.SwingUtilities;

/**
 *
 * @author  ehucka
 */
public class ErrorsDialog extends javax.swing.JDialog {
    
    PrintStream ps=null;  //only one PS for one dialog
    
    /** Creates new form ErrorsDialog */
    public ErrorsDialog(java.awt.Frame parent) {
        super(parent, false);
        initComponents();
        setSize(parent.getWidth(),300);
    }
    
    public ErrorsDialog(java.awt.Frame parent,String title) {
        super(parent, false);
        initComponents();
        setTitle(title);
        setSize(parent.getWidth(),300);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        texts = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        selectAllB = new javax.swing.JButton();
        clearB = new javax.swing.JButton();

        FormListener formListener = new FormListener();

        setTitle("Errors");
        addWindowListener(formListener);

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 10, 10, 10));
        texts.setEditable(false);
        texts.setWrapStyleWord(true);
        jScrollPane1.setViewportView(texts);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 10, 10));

        selectAllB.setFont(new java.awt.Font("Dialog", 1, 10));
        selectAllB.setText("Select All");
        selectAllB.setMargin(new java.awt.Insets(2, 5, 2, 5));
        selectAllB.setPreferredSize(new java.awt.Dimension(64, 21));
        selectAllB.addActionListener(formListener);

        jPanel2.add(selectAllB);

        clearB.setFont(new java.awt.Font("Dialog", 1, 10));
        clearB.setText("Clear");
        clearB.setMargin(new java.awt.Insets(2, 5, 2, 5));
        clearB.setPreferredSize(new java.awt.Dimension(64, 21));
        clearB.addActionListener(formListener);

        jPanel2.add(clearB);

        jPanel1.add(jPanel2, java.awt.BorderLayout.NORTH);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        pack();
    }

    // Code for dispatching events from components to event handlers.

    private class FormListener implements java.awt.event.ActionListener, java.awt.event.WindowListener {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
            if (evt.getSource() == selectAllB) {
                ErrorsDialog.this.selectAllBActionPerformed(evt);
            }
            else if (evt.getSource() == clearB) {
                ErrorsDialog.this.clearBActionPerformed(evt);
            }
        }

        public void windowActivated(java.awt.event.WindowEvent evt) {
        }

        public void windowClosed(java.awt.event.WindowEvent evt) {
        }

        public void windowClosing(java.awt.event.WindowEvent evt) {
            if (evt.getSource() == ErrorsDialog.this) {
                ErrorsDialog.this.closeDialog(evt);
            }
        }

        public void windowDeactivated(java.awt.event.WindowEvent evt) {
        }

        public void windowDeiconified(java.awt.event.WindowEvent evt) {
        }

        public void windowIconified(java.awt.event.WindowEvent evt) {
        }

        public void windowOpened(java.awt.event.WindowEvent evt) {
        }
    }// </editor-fold>//GEN-END:initComponents
    
    private void clearBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearBActionPerformed
        texts.setText("");
    }//GEN-LAST:event_clearBActionPerformed
    
    private void selectAllBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectAllBActionPerformed
        texts.grabFocus();
        texts.setCaretPosition(0);
        texts.moveCaretPosition(texts.getDocument().getLength()-1);
    }//GEN-LAST:event_selectAllBActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        //        dispose();
    }//GEN-LAST:event_closeDialog
    
    public void addText(final String text) {   //append at the begin of the document
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                if (!isVisible()) {
                    setVisible(true);
                }
                texts.append(text);
                jScrollPane1.getHorizontalScrollBar().setValue(jScrollPane1.getHorizontalScrollBar().getMaximum());
            }
        });
    }
    
    public void destroy() {
        setVisible(false);
        dispose();
    }
    
    public void setVisible(boolean value) {
        if (value) {
            setLocation(getParent().getX()+(getParent().getWidth()-getWidth())/2,
                    getParent().getY()+(getParent().getHeight()-getHeight())/2);
        }
        super.setVisible(value);
    }
    
    public PrintStream getPrintStream() {
        if (ps == null) {
            ps=new PrintStream(new OutputStream() {
                char[] buffer=new char[512];
                int i=0;
                public void write(int b) {
                    buffer[i++]=(char)b;
                    if (b == '\n') {
                        addText(new String(buffer,0,i));
                        i=0;
                    } else if (i == 512) {
                        addText(new String(buffer));
                        i=0;
                    }
                }
            });
        }
        return ps;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JButton clearB;
    public javax.swing.JPanel jPanel1;
    public javax.swing.JPanel jPanel2;
    public javax.swing.JScrollPane jScrollPane1;
    public javax.swing.JButton selectAllB;
    public javax.swing.JTextArea texts;
    // End of variables declaration//GEN-END:variables
    
}
