/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.help;

import java.util.ArrayList;
import java.util.Arrays;
import javax.swing.table.DefaultTableModel;
import org.netbeans.testspeceditor.Application;
import org.netbeans.testspeceditor.ui.actions.Action;
import org.netbeans.testspeceditor.ui.actions.ActionsManager;

/**
 *
 * @author  eh103527
 */
public class HelpDialog extends javax.swing.JDialog {
    
    int tip=0;
    String[][] actions;
    
    /** Creates new form HelpDialog */
    public HelpDialog() {
        super(Application.getInstance().getUi(), false);
        initComponents();
        buildNumberL.setText(Application.getBuildName());
        setSize(540,360);
        displayTip();
        displayKeyBindings();
        setLocation(getParent().getX()+(getParent().getWidth()-getWidth())/2,getParent().getY()+(getParent().getHeight()-getHeight())/2);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        buildNumberL = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tipArea = new javax.swing.JTextArea();
        jPanel6 = new javax.swing.JPanel();
        prevB = new javax.swing.JButton();
        nextB = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        keybindingsTable = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        closeB = new javax.swing.JButton();

        FormListener formListener = new FormListener();

        setTitle("Help");
        addWindowListener(formListener);

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 14));
        jLabel1.setText("Test Specification Editor");

        jLabel2.setText("Version:");

        jLabel3.setText("2.0");

        jLabel4.setText("Author:");

        jLabel5.setText("Emanuel Hucka");

        jLabel6.setText("E-Mail:");

        jLabel7.setText("emanuel.hucka@sun.com");

        buildNumberL.setText("6.1.2006");

        jLabel9.setText("Build number:");

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel1)
                    .add(jPanel2Layout.createSequentialGroup()
                        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel9)
                            .add(jLabel2)
                            .add(jLabel4)
                            .add(jLabel6))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel7)
                            .add(jLabel5)
                            .add(jLabel3)
                            .add(buildNumberL))))
                .add(604, 604, 604))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabel1)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(jLabel3))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel4)
                    .add(jLabel5))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel6)
                    .add(jLabel7))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(buildNumberL))
                .add(153, 153, 153))
        );
        jTabbedPane1.addTab("About", jPanel2);

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel5.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));
        tipArea.setBackground(new java.awt.Color(204, 204, 204));
        tipArea.setEditable(false);
        tipArea.setLineWrap(true);
        tipArea.setWrapStyleWord(true);
        jScrollPane1.setViewportView(tipArea);

        org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1)
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 229, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel3.add(jPanel5, java.awt.BorderLayout.CENTER);

        jPanel6.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 20, 5));

        prevB.setMnemonic('p');
        prevB.setText("<< Previous");
        prevB.setMargin(new java.awt.Insets(2, 2, 2, 2));
        prevB.setPreferredSize(new java.awt.Dimension(95, 21));
        prevB.addActionListener(formListener);

        jPanel6.add(prevB);

        nextB.setMnemonic('n');
        nextB.setText("Next >>");
        nextB.setMargin(new java.awt.Insets(2, 2, 2, 2));
        nextB.setPreferredSize(new java.awt.Dimension(95, 21));
        nextB.addActionListener(formListener);

        jPanel6.add(nextB);

        jPanel3.add(jPanel6, java.awt.BorderLayout.SOUTH);

        jTabbedPane1.addTab("Tips", jPanel3);

        jPanel4.setLayout(new java.awt.BorderLayout());

        keybindingsTable.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        keybindingsTable.setShowHorizontalLines(false);
        jScrollPane2.setViewportView(keybindingsTable);

        jPanel4.add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab("Keybindings", jPanel4);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT, 20, 10));

        closeB.setMnemonic('c');
        closeB.setText("Close");
        closeB.addActionListener(formListener);

        jPanel1.add(closeB);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }

    // Code for dispatching events from components to event handlers.

    private class FormListener implements java.awt.event.ActionListener, java.awt.event.WindowListener {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
            if (evt.getSource() == prevB) {
                HelpDialog.this.prevBActionPerformed(evt);
            }
            else if (evt.getSource() == nextB) {
                HelpDialog.this.nextBActionPerformed(evt);
            }
            else if (evt.getSource() == closeB) {
                HelpDialog.this.closeBActionPerformed(evt);
            }
        }

        public void windowActivated(java.awt.event.WindowEvent evt) {
        }

        public void windowClosed(java.awt.event.WindowEvent evt) {
        }

        public void windowClosing(java.awt.event.WindowEvent evt) {
            if (evt.getSource() == HelpDialog.this) {
                HelpDialog.this.closeDialog(evt);
            }
        }

        public void windowDeactivated(java.awt.event.WindowEvent evt) {
        }

        public void windowDeiconified(java.awt.event.WindowEvent evt) {
        }

        public void windowIconified(java.awt.event.WindowEvent evt) {
        }

        public void windowOpened(java.awt.event.WindowEvent evt) {
        }
    }// </editor-fold>//GEN-END:initComponents
    
    private void nextBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nextBActionPerformed
        tip++;
        if (tip >= Tips.getLength()) {
            tip=0;
        }
        displayTip();
    }//GEN-LAST:event_nextBActionPerformed
    
    private void prevBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_prevBActionPerformed
        tip--;
        if (tip < 0) {
            tip=Tips.getLength()-1;
        }
        displayTip();
    }//GEN-LAST:event_prevBActionPerformed
    
    private void closeBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeBActionPerformed
        // Add your handling code here:
        closeDialog(null);
    }//GEN-LAST:event_closeBActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    protected void displayTip() {
        tipArea.setText(Tips.getTip(tip));
    }
    
    protected void displayKeyBindings() {
        if (actions == null) {
            Action[] acts=ActionsManager.getInstance().findAllActions();
            Arrays.sort(acts);
            ArrayList<Action> list=new ArrayList(acts.length);
            for (int i = 0; i < acts.length; i++) {
                if (acts[i].getKeyStroke() != null) {
                    list.add(acts[i]);
                }
            }
            actions=new String[list.size()][3];
            for (int i = 0; i < list.size(); i++) {
                Action ac=list.get(i);
                actions[i][0]=ac.getName();
                String keys=ac.getKeyStroke().toString();
                keys=keys.replace("pressed ", "");
                keys=keys.replace(" ", "+");
                keys=keys.replace("shift", "Shift");
                keys=keys.replace("ctrl", "Ctrl");
                keys=keys.replace("alt", "Alt");
                actions[i][1]=keys;
                actions[i][2]=ac.getHelpCtx();
            }
            keybindingsTable.setModel(new DefaultTableModel(actions,
                    new String[] {"Action", "KeyBinding", "Description"}));
        }
        /*keybindingsTable.setModel(new javax.swing.table.DefaultTableModel(KeyBindings.TABLE,
        new String [] {
            "Key Bindings", "Descriptions"
        }
        ));*/
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel buildNumberL;
    private javax.swing.JButton closeB;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTable keybindingsTable;
    private javax.swing.JButton nextB;
    private javax.swing.JButton prevB;
    private javax.swing.JTextArea tipArea;
    // End of variables declaration//GEN-END:variables
    
}
