/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.testspeceditor.utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintStream;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author ehucka
 */
public class FileUtilTest {

    public FileUtilTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of copyFiles method, of class FileUtil.
     */
    @Test
    public void copyFiles() throws Exception {
        System.out.println("copyFiles");
        try {
            String text = "test text";
            File file = createTmpFile(text);
            File copyTo = File.createTempFile("test", ".txt");
            FileUtil.copyFiles(file, copyTo);
            String content = getContent(copyTo);
            file.delete();
            copyTo.delete();
            assertEquals(text, content);
        } catch (Exception ex) {
            ex.printStackTrace();
            fail(ex.getMessage());
        }
    }

    protected File createTmpFile(String content) throws Exception {
        File ret = File.createTempFile("test", ".txt");
        PrintStream ps = new PrintStream(ret);
        try {
            ps.print(content);
        } finally {
            ps.close();
        }
        return ret;
    }

    protected String getContent(File file) throws Exception {
        BufferedReader br = new BufferedReader(new FileReader(file));
        try {
            StringBuilder sb = new StringBuilder();
            String line;
            while ((line = br.readLine()) != null) {
                if (sb.length() > 0) {
                    sb.append("\n");
                }
                sb.append(line);
            }
            return sb.toString();
        } finally {
            br.close();
        }
    }
    /**
     * Test of safelyRenameFiles method, of class FileUtil.
     */

    @Test
    public void safelyRenameFiles() throws Exception {
        System.out.println("safelyRenameFiles");
        File file = null;
        try {
            String text = "test text";
            file = createTmpFile(text);
            File renameTo = File.createTempFile("test", ".txt");
            FileUtil.safelyRenameFiles(file, renameTo);
            String content = getContent(renameTo);
            renameTo.delete();
            assertFalse(file.exists());
            assertEquals(text, content);
        } catch (Exception ex) {
            ex.printStackTrace();
            fail(ex.getMessage());
        } finally {
            if (file != null && file.exists()) {
                file.delete();
            }
        }
    }
}