/*
                    Sun Public License Notice
 
The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/
 
The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.
 
Contributor(s): Petr Slegr.
 */

package org.netbeans.modules.regsup.auted;

/**
 *
 * @author Petr Slegr
 * @version 09.05.02
 */
public class ContainerGeometryFactory implements GeometryFactory {
    
    /**
     */
    public ElementGeometry create (VisualAutomatonElement element) {
        if (! element.getClass ().equals (VisualAutomatonContainer.class)) {
            throw new IllegalArgumentException ("VisualAutomatonContainer required, got: " + element);
        }
        VisualAutomatonContainer container = (VisualAutomatonContainer) element;
        return new ContainerGeometry (container);
    }
    
}
