/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted;

import javax.swing.JPanel;
import java.util.TooManyListenersException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import org.netbeans.modules.regsup.logic.aut2expr.ResolveResult;
import javax.swing.DefaultListModel;
import org.netbeans.modules.regsup.auted.ui.ResultListRenderer;
import java.util.Iterator;
import java.util.Set;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import org.netbeans.modules.regsup.logic.aut2expr.ResolveProblem;
import java.util.List;
import java.util.Collections;

/**
 *
 * @author  Petr Slegr
 * @version 16.03.02
 */
class EvaluatePanel extends JPanel {
    
    private ResolveResult result;
    
    private AutomatonEditorPanel parent;
    
    /** Last path to place of problems. Due to resetErrorElements ().
     */
    private List path;
    
    /** Creates new form EvaluatePanel */
    public EvaluatePanel (AutomatonEditorPanel parent) {
        this.parent = parent;
        initComponents ();
        //evaluateButton.addActionListener (new EvaluateButtonListener ());
        resultList.addMouseListener (new ResultListListener ());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        evaluateButton = new javax.swing.JButton();
        expressionPanel = new javax.swing.JPanel();
        expressionLabel = new javax.swing.JLabel();
        expressionTextField = new javax.swing.JTextField();
        problemPanel = new javax.swing.JPanel();
        resultScrollPane = new javax.swing.JScrollPane();
        resultList = new javax.swing.JList();
        problemCount = new javax.swing.JLabel();

        setLayout(new java.awt.GridBagLayout());

        jPanel1.setLayout(new java.awt.GridBagLayout());

        evaluateButton.setText("Evaluate");
        evaluateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                evaluateButtonActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel1.add(evaluateButton, gridBagConstraints);

        expressionPanel.setLayout(new java.awt.GridBagLayout());

        expressionLabel.setText("Expression");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        expressionPanel.add(expressionLabel, gridBagConstraints);

        expressionTextField.setFont(new java.awt.Font("Dialog", 1, 12));
        expressionTextField.setMinimumSize(new java.awt.Dimension(300, 21));
        expressionTextField.setPreferredSize(new java.awt.Dimension(300, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        expressionPanel.add(expressionTextField, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel1.add(expressionPanel, gridBagConstraints);

        problemPanel.setLayout(new java.awt.GridBagLayout());

        problemPanel.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(1, 1, 1, 1)), "Problems"));
        resultScrollPane.setMinimumSize(new java.awt.Dimension(22, 90));
        resultScrollPane.setPreferredSize(new java.awt.Dimension(250, 60));
        resultList.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        resultScrollPane.setViewportView(resultList);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        problemPanel.add(resultScrollPane, gridBagConstraints);

        problemCount.setText("                  ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        problemPanel.add(problemCount, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel1.add(problemPanel, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

    }//GEN-END:initComponents

    private void evaluateButtonActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_evaluateButtonActionPerformed
        parent.evaluateAutomaton ();
        // debug
        //GeometryFactoryRegistry.setFactory (VisualAutomatonNode.class, new TestNodeGeometryFactory ());
        // debug
        /*
        double coef = 1.2;
        ContainerGeometry.BASE = (int) ContainerGeometry.BASE * coef;
        ContainerGeometry.LONG_SIDE = (int) ContainerGeometry.LONG_SIDE * coef;
        ContainerGeometry.SHORT_SIZE = (int) ContainerGeometry.SHORT_SIZE * coef;
         */
        // end debug
        parent.repaint ();
    }//GEN-LAST:event_evaluateButtonActionPerformed
    
    /**
     */
    String getExpressionString () {
        return expressionTextField.getText ();
    }
    
    /** Not used yet.
     */
    ResolveResult getResultData () {
        return result;
    }

    /**
     */
    void setResultData (ResolveResult result) {
        this.result = result;
        DefaultListModel resultModel = new DefaultListModel ();
        //resultList.setModel (resultModel);
        resultList.setCellRenderer (new ResultListRenderer ());
        if (result.isOk ()) {
            if (result.getWarnings ().size () == 0) {
                // only if no warning (//! was bug)
                resultModel.addElement (result);
            }
            // very different type (instead something like ResolveProblemOk :o)
            expressionTextField.setText (result.getExpression ().toString ());
        } else {
            /*
            it = result.getWarnings ().iterator ();
            while (it.hasNext ()) {
                resultModel.addElement (it.next ());
            }
             */
            expressionTextField.setText ("<Incorrect automaton graph>");
        }
        // ! need not be controled by isOk () (was bug - was only in !isOk ())
        Set problems = result.getProblems ();
        Iterator it = problems.iterator ();
        while (it.hasNext ()) {
            resultModel.addElement (it.next ());
        }
        resultList.setModel (resultModel);
        resultList.revalidate ();
        resultList.repaint ();
        int warns = result.getWarnings ().size ();
        int errs = result.getErrors ().size ();
        StringBuffer buf = new StringBuffer ();
        buf.append ("Errors ");
        buf.append (errs);
        buf.append ("  Warnings ");
        buf.append (warns);
        problemCount.setText (buf.toString ());
        //
        if (path != null) {
            // path to place of problem has been seted
            setErrorInEditors (path, false); // clearing
        }
    }
    
    /**
     * @param set true set, false reset
     */
    private void setErrorInEditors (List path, boolean set) {
        for (Iterator it = path.iterator (); it.hasNext (); ) {
            VisualAutomatonNode node = (VisualAutomatonNode) it.next ();
            VisualAutomatonContainer container = node.getContainer ();
            AutomatonEditor editor = MainManager.getDefault ().createEditor (container);
            if (set) {
                editor.setErrorElements (Collections.singleton (node));
            } else {
                editor.resetErrorElements ();
            }
        }
    }
    
    /**
     */
    private void showProblemInPanel (List path) {
        VisualAutomatonContainer cont = parent.getRootEditor ().getContent ();
        // bugfix
        if (path.size () < 1) {
            // neither last node nor container are contained in path
            return;
        }
        // end of bugfix
        VisualAutomatonNode last = (VisualAutomatonNode) path.get (path.size () - 1);
        VisualAutomatonContainer target = null;
        VisualAutomatonNode causeNode = null;
        // path ends by VisualAutomatonContainer
        if (last instanceof VisualAutomatonContainer) {
            target = (VisualAutomatonContainer) last;
        } else {
            // path ends by VisualAutomatonNode
            causeNode = last;
            if (path.size () > 1) {
                // path is not only one VisualAutomatonNode
                target = (VisualAutomatonContainer) path.get (path.size () - 2);
            }
        }
        //
        if (target != null) {
            //AutomatonEditor editor = MainManager.getDefault ().createEditor (target);
            AutomatonPanel panel = AutomatonPanel.createFor (target);
            parent.changeViewTo (panel);
        }
    }
    
    ////////////////////////////////////////////////////////////////////////////
    private class ResultListListener extends MouseAdapter {
        
        /**
         * Invoked when the mouse has been clicked on a component.
         */
        public void mouseClicked (MouseEvent e) {
            // double-click
            if (e.getClickCount () == 2) {
                //System.out.println("clicked: " + resultList.getSelectedValue ());
                Object o = resultList.getSelectedValue ();
                if (o instanceof ResolveProblem) {
                    ResolveProblem problem = (ResolveProblem) o;
                    path = parent.getRootEditor ().getContent ().findPlaceOf (problem);
                    setErrorInEditors (path, true);
                    showProblemInPanel (path);
                }
            }
        }
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel expressionLabel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel problemCount;
    private javax.swing.JButton evaluateButton;
    private javax.swing.JPanel problemPanel;
    private javax.swing.JList resultList;
    private javax.swing.JTextField expressionTextField;
    private javax.swing.JScrollPane resultScrollPane;
    private javax.swing.JPanel expressionPanel;
    // End of variables declaration//GEN-END:variables
    
    /** Utility field holding the ActionListener. */
    private transient ActionListener actionListener =  null;
    
}
