/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted;

/**
 *
 * @author  Petr Slegr
 * @version 22.04.02
 */
public class PaintDescriptor {
    
    public final Class clazz;
    
    public final int mode;
    
    // zero means unassigned mode
    
    public static final int NORMAL = 1;
    
    public static final int ACTIVE = 2;
    
    public static final int ERROR = 3;
    
    public static final int WARNING = 4;
    
    public static final int BREAKPOINT = 5;
    
    public static final int SELECTED = 6;
    
    /** Creates a new instance of PaintDescriptor 
     * @param clazz null is allowed. Null means that no matter on class only on
     * mode (e.g. selected).
     * @param mode zero means that no matter on mode only on class
     * @throws IllegalArgumentException if both null and zero are used
     */
    public PaintDescriptor (Class clazz, int mode) {
        if (clazz != null && ! VisualAutomatonElement.class.isAssignableFrom (clazz)) {
            throw new IllegalArgumentException ("Improper clazz: " + clazz);
        }
        // zero means unassigned mode
        // selected is highest used number
        if (mode < 0 || mode > SELECTED) {
            throw new IllegalArgumentException ("Unknown mode: " + mode);
        }
        if (clazz == null && mode == 0) {
            throw new IllegalArgumentException ("At least one param must be specified");
        }
        this.clazz = clazz;
        this.mode = mode;
    }
    
}
