/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.ide;

import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.NodeAction;
import org.netbeans.modules.regsup.auted.MainManager;
import org.openide.windows.Workspace;
import org.openide.TopManager;
import org.openide.windows.WindowManager;
import org.openide.windows.Mode;
import org.netbeans.modules.regsup.auted.VisualAutomatonContainer;
import java.awt.Point;
import org.netbeans.modules.regsup.auted.AutomatonEditor;

/** Action for debug purposes (like opening of regsup window)
 * @author  Petr Slegr
 */
public class OpenRegsupAction extends NodeAction {
    
    protected void performAction (Node[] nodes) {
        //MainManager.main (new String [0]);
        WindowManager winmgr = TopManager.getDefault ().getWindowManager ();
        Workspace spc = winmgr.findWorkspace ("Editing");
        //System.out.println("modes: " + spc.getModes ());
        Mode mode = spc.findMode ("editor");
        System.out.println("mode: " + mode);
        mode = spc.findMode ("output");
        System.out.println("mode: " + mode);
        /*
        VisualAutomatonContainer container = new VisualAutomatonContainer (null, new Point ());
        AutomatonEditor editor = MainManager.getDefault ().createEditor (container);
        MainManager.debugSetup31 (container);
        RegsupWindow win = new RegsupWindow (editor);
        win.open ();
         */
        // Note that casting to a type of node is often not the right
        // solution; try using a CookieAction, unless it is really the
        // node itself and not the underlying data that needs to be
        // considered. Also remember that some tests on nodes (casts
        // as well as reorderability of children etc.) will not work
        // when applied to filter nodes, whereas cookies will.
    }
    
    protected boolean enable (Node[] nodes) {
        return true;
    }
    
    public String getName () {
        return NbBundle.getMessage (OpenRegsupAction.class, "LBL_Action");
    }
    
    protected String iconResource () {
        return "OpenRegsupActionIcon.gif";
    }
    
    public HelpCtx getHelpCtx () {
        return HelpCtx.DEFAULT_HELP;
        // If you will provide context help then use:
        // return new HelpCtx (OpenRegsupAction.class);
    }
    
    /** Perform extra initialization of this action's singleton.
     * PLEASE do not use constructors for this purpose!
     * protected void initialize () {
     * super.initialize ();
     * putProperty (Action.SHORT_DESCRIPTION, NbBundle.getMessage (OpenRegsupAction.class, "HINT_Action"));
     * }
     */
    
}
